#!/bin/sh

function usage () {
	cat <<EOF
Usage: $0 <backupfilefullpath>
EOF
	exit -2
}

[ $# -lt 1 ] && usage
[ $# -gt 1 ] && usage


WD=$(echo $0 | awk '{sub(/\/[^\/]*?$/,""); print}')
source $WD/variables.sh
BUFILE=$1

mkdir -p $BUDIR/tmp

for i in $BUFILES;
do 
	rm -f $BUFILE $BUDIR/tmp/$i.tgz $BUDIR/tmp/$i.sha1
done;

for i in $BUFILES;
do
	tar -C $CFDIR -zcf $BUDIR/tmp/$i.tgz $(cd $CFDIR; ls */*.data);
	sha1sum $BUDIR/tmp/$i.tgz > $BUDIR/tmp/$i.sha1;
done;

tar -C $BUDIR/tmp -zcf $BUFILE .
[ -e $BUFILE ] || exit -3
# rm -rf $BUDIR/tmp

exit 0
