#!/bin/sh

function usage () {
	cat <<EOF
Usage: $0
EOF
	exit 2
}

[ $# -lt 0 ] && usage
[ $# -gt 0 ] && usage

WD=$(echo $0 | awk '{sub(/\/[^\/]*?$/,""); print}')
source $WD/variables.sh
BUFILE=$1;
UGDIR=$BUDIR/upgrade

FAIL=0;
for i in $BUFILES;
do 
	if [[ ! -e $UGDIR/$i.sha1 ]] 
	then
		FAIL=-1
	elif [[ $(cat $UGDIR/$i.sha1) -ne $(sha1sum $UGDIR/$i.tgz) ]] 
	then
		FAIL=-1
	fi
done

exit $FAIL

