#!/bin/sh

function usage () {
	cat <<EOF
Usage: $0 <backupfilefullpath>
EOF
	exit -1
}

[ $# -lt 1 ] && usage
[ $# -gt 1 ] && usage

BUFILE=$1



# FIXME shorts out this script if we're developing on a desktop.
if [[ $( cat /proc/cpuinfo | grep -c 'Intel' ) -ge 1 ]]
then
# we're on a Desktop
	exit 0
fi

if [[ $( df -h | grep -c '/mnt/usbdisk' ) -lt 1 ]]
then
# not mounted
	exit -5
fi

USBAVAIL=$( df | grep /mnt/usbdisk | awk '{print $4}' )
FILESIZE=$( ls -l $BUFILE | awk '{print $5}' )

# echo $USBAVAIL $FILESIZE

if [[ $USBAVAIL -gt $FILESIZE ]] 
then
# SUCCESS
	exit 0
else
# FAIL
	exit -1
fi

