#!/bin/sh
#################################################################
# TS7260 mounting USB pendrive script in usb port 0 (top drive )
#    a.k.a : memory stick
#    a.k.a : thumbdrive
#
# dependencies load the fat and vfat filesystems at boot time
#    edit the /etc/modules file uncommenting the lines
#
# #===========================================================
# # /etc/modules
# # =========================================================
# fat
# vfat 
# #af-packet
# #usb-ohci
# #usb-ohci-ep93xx
# usbcore
# zd
# pcipool
# #usb-ohci
# #usb-ohci-ep93xx
# af-packet
#
#################################################################

# # FIXME shorts out this script if we're developing on a desktop.
# if [[ $( cat /proc/cpuinfo | grep -c 'Intel' ) -ge 1 ]]
# then
# # we're on Debian
# 	exit 0
# fi

if [[ $( df -h | grep -c '/mnt/usbdisk' ) -ge 1 ]]
then
# already mounted
	exit 0
fi

DEVPATH=/dev/scsi/host0/bus0/target0/lun0
insmod fat				> /dev/null
insmod vfat				> /dev/null
insmod usbcore			> /dev/null
insmod pcipool			> /dev/null
insmod usb-ohci			> /dev/null
insmod usb-ohci-ep93xx	> /dev/null
insmod scsi_mod			> /dev/null
insmod sd_mod			> /dev/null
insmod usb-storage		> /dev/null

# this cleans up part1 from dev, if it existed before, but usb stick
# was removed afterwards
ls $DEVPATH > /dev/null

# i=-10; until [[ $i -ge 0 ]]; do echo $i; let i++; done;
i=-10
until [[ $i -ge 0 ]] || test -e $DEVPATH/part1
do
	ls $DEVPATH > /dev/null
	usleep 1000000
	let i++
done

if [[ -e $DEVPATH/part1 ]] 
then
	mount -t vfat $DEVPATH/part1 /mnt/usbdisk -o async,noatime,nodiratime,nodev,noexec,nosuid,gid=100,umask=002
	exit 0
fi

# FAIL
exit -1

