#!/bin/sh
###########################################################
#
# ------------------------------------------------------
# Copyright(c) 2008: Southwest Microwave, Inc.
# All rights reserved. Proprietary and confidential.
# Unauthorized reproduction, distribution , 
# modification is not permitted.
# ------------------------------------------------------
#
# FILENAME : 
#     /smi/config/comms/mkHosts.sh
#
# PURPOSE  : 
#     Modify /etc/hosts 
#
# HISTORY:
#     Sep 15, 2008 : JFD : Creation
#
# --------------------------------------------------------
# CVS Keywords : Automatically generated , do not edit
# --------------------------------------------------------
#
###########################################################
function usage () {
	cat <<EOF
Usage: $0 
Example:
	$0
EOF
	exit 1
}

[ $# -ne 0 ] && usage

###############################################################
# hosts file aliases
###############################################################
TFILE="/smi/etc/hosts"
WFILE="/etc/hosts"

######################################################################
# update the temp hosts configuration file with data from
# the site installer's configuration file 
# /smi/config/comms/smiCmLan.data 
######################################################################
HNAME=$(awk '/ethernet_host_name/ {print $2}' /smi/config/comms/smiCmLan.data)
IPADDR=$(awk '/ethernet_ipAddr/ {print $2}' /smi/config/comms/smiCmLan.data)

echo "smiCmLan.data hostname = $HNAME"
echo "smiCmLan ipaddr = $IPADDR"
echo "creating temp host configuration file $TFILE"

echo "127.0.0.1  localhost localhost" > $TFILE
echo "$IPADDR $HNAME" >> $TFILE


######################################################################
# update /usr/local/apache2/conf/httpd.conf with new settings
######################################################################
sudo cp $TFILE $WFILE  

######################################################################
# done
######################################################################
exit 0;


