#!/bin/sh
###########################################################
#
# ------------------------------------------------------
# Copyright(c) 2008: Southwest Microwave, Inc.
# All rights reserved. Proprietary and confidential.
# Unauthorized reproduction, distribution , 
# modification is not permitted.
# ------------------------------------------------------
#
# FILENAME : 
#     /smi/config/comms/mkHttpConf.sh
#
# PURPOSE  : 
#     Modify /usr/local/apache2/conf/httpd.conf 
#     ServerName and Listen variable to fully qualified
#     ipAddress and httpd port number
#
# HISTORY:
#     Sep 5, 2008 : JFD : Creation
#
# --------------------------------------------------------
# CVS Keywords : Automatically generated , do not edit
# --------------------------------------------------------
#
###########################################################
function usage () {
	cat <<EOF
Usage: $0 
Example:
	$0
EOF
	exit 1
}

[ $# -ne 0 ] && usage

###############################################################
# setup directory paths
###############################################################
PATH=$PATH:/usr/local/apache2/bin
WD="/smi/config/comms"
TAD="/smi/usr/local/apache2/conf"
AD="/usr/local/apache2/conf"

###############################################################
# apache2 configuration files
###############################################################
TAPACFILE="$TAD/httpd.conf"
APACFILE="$AD/httpd.conf"

######################################################################
# update the temp apache2 configuration file with data from
# the site installer's configuration file 
# /smi/config/comms/smiCmLan.data 
######################################################################
cp $APACFILE $TAD/httpd.conf.bk || { echo "Could not write to backup network files"; exit 2; }
PORT=$(awk '/ethernet_http_port/ {print $2}' $WD/smiCmLan.data)
IPADDR=$(awk '/ethernet_ipAddr/ {print $2}' $WD/smiCmLan.data)

#echo "modifying temp apache2 configuration file $TAPACFILE"
sed -e "s/Listen [0-9].*:[0-9].*/Listen $IPADDR:$PORT/" $APACFILE > $TAD/httpd.conf.tmp || { echo "Could not change $TAD/httpd.conf.tmp from $APACFILE"; exit 3; }
sed -e "s/ServerName [0-9].*:[0-9]*/ServerName $IPADDR:$PORT/" $TAD/httpd.conf.tmp > $TAD/httpd.conf || { echo "Could not change $TAD/httpd.conf from $TAD/httpd.conf.tmp"; exit 3; }
chmod 777 $TAD/* || { echo "Could not change system permissions to temp httpd.conf"; exit 3; }
chown www-data:www-data $TAD/* || { echo "Could not change system ownership to temp httpd.conf"; exit 3; }

######################################################################
# update /usr/local/apache2/conf/httpd.conf with new settings
######################################################################
sudo chown www-data:www-data $APACFILE 2> /dev/null
cp $TAD/httpd.conf $APACFILE || { echo "Could not write to final network files"; exit 4; }

######################################################################
# done
######################################################################
exit 0;


