#!/bin/sh
###########################################################
#
# ------------------------------------------------------
# Copyright(c) 2008: Southwest Microwave, Inc.
# All rights reserved. Proprietary and confidential.
# Unauthorized reproduction, distribution , 
# modification is not permitted.
# ------------------------------------------------------
#
# FILENAME : 
#     /smi/config/comms/mkDebianPcEth0.sh
#
# PURPOSE  : 
#     update kernel network interface eth0 
#     update apache2 configuration file
#     update kernel host configuration file
#
# HISTORY:
#     Sep 24, 2008 : JFD : Creation
# 
# --------------------------------------------------------
# CVS Keywords : Automatically generated , do not edit
# --------------------------------------------------------
# $Source: /usr/local/cvsroot/cm_II/smi/config/comms/mkTs7260Eth0.sh,v $ 
# $Revision: 1.1 $
# $Date: 2008/09/24 19:25:26 $ 
# 
###########################################################
function usage () {
	cat <<EOF
Usage: $0 
Example:
	$0
EOF
	exit 1
}

[ $# -ne 0 ] && usage

###############################################################
# setup directory paths
###############################################################
WD="/smi/config/comms"
TD="/smi/etc"
FD="/etc"

################################################################
# networking files
################################################################
THEFILES="network/interfaces networks resolv.conf hostname hosts" 
TMPFILES=""
BKPFILES=""
ETCFILES=""
APACFILE=""
ALLFILES=""
for i in $THEFILES
do
	TMPFILES="$TMPFILES $TD/$i"
	BKPFILES="$BKPFILES $TD/$i.bk"
	ETCFILES="$ETCFILES $FD/$i"
done

###############################################################
# test targets
###############################################################
ALLFILES="$TMPFILES $BKPFILES $ETCFILES $APACFILE"

for i in $ALLFILES
do
   sudo touch $i || { echo "Could not write to network files"; exit 1; }
done

######################################################################
# update the temp networking files with data from site installer's
# configuration file /smi/config/comms/smiCmLan.data
######################################################################
awk -f $WD/mkNetworkInterfaces.awk $WD/smiCmLan.data  > $TD/network/interfaces
awk -f $WD/mkResolvConf.awk $WD/smiCmLan.data > $TD/resolv.conf
awk -f $WD/mkNetworks.awk $WD/smiCmLan.data > $TD/networks
awk -f $WD/mkHostname.awk $WD/smiCmLan.data   > $TD/hostname

#######################################################################
# perform backup of original /etc/network/interface , 
# /etc/resolv.conf /etc/networks /etc/hostname /etc/hosts files to
# /smi/etc directory
#######################################################################
for i in $THEFILES
do
	cp $FD/$i $TD/$i.bk || { echo "Could not write to backup network files"; exit 2; }
	chmod 777 $TD/*
	chown www-data:www-data $TD/*
done

######################################################################
# update networking files 
#       /etc/network/interfaces
#       /etc/networks
#       /etc/hostname
#       /etc/resolv.conf 
######################################################################
for i in $THEFILES
do
	chmod 777 $FD/$i
	chown www-data:www-data $FD/$i 
	cp $TD/$i $FD/$i || { echo "Could not write to final network files"; exit 3; }
done

######################################################################
# update /etc/hosts with new host name
######################################################################
/smi/config/comms/mkHosts.sh

######################################################################
# update apache config with new ipaddress and port number 
######################################################################
/smi/config/comms/mkHttpdConf.sh

######################################################################
# done
######################################################################
exit 0;

