#!/bin/sh
#//////////////////////////////////////////////////////////////////
#// 
#//------------------------------------------------------------
#// Copyright(c) 2008: Southwest Microwave,Inc.
#//------------------------------------------------------------
#// 
#// FILENAME:
#//    restoreDefaults.sh
#//
#// PURPOSE:
#//    bourne shell script to restore Intrepid-II CM
#//    device configuration files to factory default values
#//
#////////////////////////////////////////////////////////////////////

#/////////////////////////////////////////////////////////////////////
#// local variables
#/////////////////////////////////////////////////////////////////////
counter=0
max=16

prefix="/smi/config/devices/smiCmDev_"
suffix=".data"
defSuffix=".def"
bkup=".prev"
defaultFilename="/smi/config/devices/smiCmDev.def"



for (( counter = 1, deviceId= 0; counter <= max; counter++, deviceId++ ))
do
    filename=($prefix$counter$suffix)
    bkupFilename=($filename$bkup)

#///////////////////////////////////////////////////////////////////
#// create default file
#///////////////////////////////////////////////////////////////////
    echo "create default file for $filename"
    chmod 777 $defaultFilename
    cp -f $defaultFilename $filename
    chmod 777 $filename
    chown www-data *
    chgrp www-data *

#////////////////////////////////////////////////////////////////////
#// replace banner strings
#////////////////////////////////////////////////////////////////////
    echo "replaceString = smiCmDev_'$counter'.data"
    cat $filename | \
        sed -e 's/smiCmDev_1.def/smiCmDev_'$counter'.data/' > temp1

    echo "replaceString = Device File  $counter"
    cat temp1 | \
        sed -e 's/Device 1/Device '$counter'/' > temp2

    echo "replaceString = $deviceId"
    cat temp2 | sed -e 's/deviceId= 0/deviceId= '$deviceId'/' > temp3
    rm $filename
    rm temp1 temp2
    mv temp3 $filename

#////////////////////////////////////////////////////////////////////////
#// display file contents
#////////////////////////////////////////////////////////////////////////
#    echo ".................Displaying $filename contents............"
#    cat $filename
#
#    echo "Would you like to continue?[y/n]"
#    read answer
#    if [ "$answer" = n ]
#    then
#        echo "Exiting program now...bye"
#        exit 0
#    fi
done


echo "Restoration completed...bye now"
#////////////////////////////////////////////////////////////////
# end
#////////////////////////////////////////////////////////////////
