#!/bin/sh
#//////////////////////////////////////////////////////////////////
#// 
#//------------------------------------------------------------
#// Copyright(c) 2008: Southwest Microwave,Inc.
#//------------------------------------------------------------
#// 
#// FILENAME:
#//    restoreDefaults.sh
#//
#// PURPOSE:
#//    bourne shell script to restore Intrepid-II CM
#//    pollmaster configuration files to factory default values
#//
#// ===============================================================
#// CVS Keywords
#// ===============================================================
#// $Source : $
#// $Revision: 1.4 $
#// $Date: 2008/09/25 17:38:17 $
#//
#////////////////////////////////////////////////////////////////////

echo "************** CREATING DEFAULT CM-II Poll Master Record Files..."

#/////////////////////////////////////////////////////////////////////
#// local variables
#/////////////////////////////////////////////////////////////////////
counter=0
max=2
prefix="/smi/config/pmasters/smiCmPmaster_"
suffix=".data"
bkup=".prev"
defaultFilename="/smi/config/pmasters/smiCmPmaster.def"
for (( counter = 1, pmasterId= 0; counter <= max; counter++, pmasterId++ ))
do
    filename=($prefix$counter$suffix)
    bkupFilename=($filename$bkup)

#    echo "**********DEBUG INFO ****************************"
#    echo "Iteration $counter..."
#    echo "pmaster id = $pmasterId"
#    echo "Poll Master Configuration Filename = $filename"
#    echo "Default filename = $defaultFilename"
#    echo "Zone Record backup filename = $bkupFilename"
#    echo ""
#///////////////////////////////////////////////////////////////////
#// create default file
#///////////////////////////////////////////////////////////////////
    echo "create default file for $filename"
    chmod 777 $defaultFilename
    cp -f $defaultFilename $filename
    chmod 777 $filename
    chgrp www-data *
    chown www-data *

#////////////////////////////////////////////////////////////////////
#// replace banner strings
#////////////////////////////////////////////////////////////////////
    echo "replaceString = smiCmPmaster_'$counter'.data"
    cat $filename | \
        sed -e 's/smiCmPmaster_1.def/smiCmPmaster_'$counter'.data/' > temp1

    echo "replaceString = Pollmaster $counter"
    cat temp1 | \
        sed -e 's/Pollmaster 1/Pollmaster '$counter'/' > temp2

    echo "replaceString = $pmasterId"
    cat temp2 | sed -e 's/pmasterId= 0/pmasterId= '$pmasterId'/' > temp3
    rm $filename
    rm temp1 temp2
    mv temp3 $filename
#////////////////////////////////////////////////////////////////////////
#// display file contents
#////////////////////////////////////////////////////////////////////////
#    echo ".................Displaying $filename contents............"
#    cat $filename
#
#    echo "Would you like to continue?[y/n]"
#    read answer
#    if [ "$answer" = n ]
#    then
#        echo "Exiting program now...bye"
#        exit 0
#    fi


done


echo "Restoration completed...bye now"

