#!/bin/sh
################################################################
# 
# -----------------------------------------------------------
# Copyright(c) 2008: Southwest Microwave, Inc.
# All rights reserved. Proprietary and Confidential material.
# Unauthorized reproduction, modification, distribution
# is not permitted.
# ------------------------------------------------------------
#
# FILENAME:
#      setCfg.sh
#
# PURPOSE:
#      replace timezone in smiCmCfg.data with /etc/timezone 
#
# SYNTAX:
#      ./setCfg.sh pathName 
#       where pathName is the directory where smiCmCfg.data resides
#
# HISTORY:
#       Aug 8, 2008 : JFD : Creation
#
# ----------------------------------------------------------
# CVS Keywords
# ----------------------------------------------------------
# $Source: /usr/local/cvsroot/cm_II/smi/config/site/setCfg.sh,v $
# $Revision: 1.1 $
# $Date: 2008/09/30 17:05:46 $
#
#
################################################################
function usage () {
        cat <<EOF
Usage: $0 smiDirectoryName
Examples:
        $0 /smi/config/site
        $0 /mnt/flash/smi/config/site
EOF
        exit 1
}

[ $# -lt 1 ] && usage

##########################################################
# delete line containing timezone string 
##########################################################
cp $1/smiCmCfg.data temp1
sed '/^timezone/d' temp1 > temp2

##########################################################
# now add the current timezone to the last line of file 
##########################################################
myTZ=`cat /etc/timezone`
echo "timezone= "$myTZ >> temp2

##########################################################
# add white space to the last line
##########################################################
sed -e 's/$/  /g' temp2 > temp3

##########################################################
# now replace smiCmCfg.data
##########################################################
rm temp1 temp2
chmod 777 temp3
mv temp3 $1/smiCmCfg.data
echo "done..added $myTz to "$1/smiCmCfg.data
cat $1/smiCmCfg.data

##########################################################
# now set the hwclock
##########################################################
sudo hwclock -systohc
sudo date


