#!/bin/sh
################################################################
# filename : setTZ.sh
# purpose  : update /etc/timezone
################################################################
echo "reading /etc/timezone contents..."
currTZ=`cat /etc/timezone`
echo "current timezone = "$currTZ

echo "Enter a POSIX TZ string (i.e: America/Phoenix ):"
read newTZ
echo "new timezone = "$newTZ

########################################################
# validate new timezone
########################################################
echo "checking $newTZ in /usr/share/zoneinfo"
verify=/usr/share/zoneinfo/$newTZ
result=`ls /usr/share/zoneinfo/$newTZ`
if [ "$verify" != "$result" ] 
then
   echo "ERROR!!! $newTZ not in /usr/share/zoneinfo..."
   exit -1 
fi

########################################################
# update /etc/timezone
# don't forget to update /smi/config/site/smiCmCfg.data!
########################################################
echo "good new timezone!!"
echo "updating /etc/timezone..."
echo $newTZ > /etc/timezone
myTZ=`cat /etc/timezone`
echo "/etc/timezone contents = "$myTZ

########################################################
# relink the localtime setting
########################################################
sudo zic -l $myTZ

########################################################
# update smiCmCfg.data
########################################################
/smi/config/site/setCfg.sh /smi/config/site

