#!/bin/sh
#//////////////////////////////////////////////////////////////////
#// 
#//------------------------------------------------------------
#// Copyright(c) 2008: Southwest Microwave,Inc.
#//------------------------------------------------------------
#// 
#// FILENAME:
#//    restoreDefaults.sh
#//
#// PURPOSE:
#//    bourne shell script to restore Intrepid-II CM
#//    zone configuration files to factory default values
#//
#////////////////////////////////////////////////////////////////////

#/////////////////////////////////////////////////////////////////////
#// local variables
#/////////////////////////////////////////////////////////////////////
counter=0
max=256

prefix="/smi/config/zones/smiCmZone_"
suffix=".data"
defSuffix=".def"


for (( counter = 1, zoneId = 0; counter <= max; counter++, zoneId++ ))
do
    filename=($prefix$counter$suffix)
    defFilename=($prefix$counter$defSuffix)

    echo "copy $defFilename to  $filename..."
    cp $defFilename $filename

    echo "**********DEBUG INFO ****************************"
    echo "Iteration $counter..."
    echo "Zone id = $zoneId"
    echo "Zone Record filename = $filename"
    echo "Default filename = $defaultFilename"
    echo ""

    echo "replaceString = smiCmZone_'$counter'.data"
    cat $filename | \
        sed -e 's/smiCmZone_1.def/smiCmZone_'$counter'.data/' > temp1

    echo "replaceString = Zone Record $counter"
    cat temp1 | \
        sed -e 's/Zone Record 1/Zone Record '$counter'/' > temp2

    echo "replaceString = $zoneId"
    cat temp2 | sed -e 's/zoneId= 0/zoneId= '$zoneId'/' > temp3
    rm $filename

    echo "replaceString = comment"
    cat temp3 | \
	sed -e 's/RECORD 1 NAME/RECORD '$counter' NAME/' > temp4

    echo "replaceString = name"
    cat temp4 | \
	sed -e 's/RECORD 1 COMMENT/RECORD '$counter' COMMENT/' > temp5

    mv temp5 $filename
    rm temp1 temp2 temp3 temp4

done

echo "Restoration completed...bye now"
#////////////////////////////////////////////////////////////////
# end
#////////////////////////////////////////////////////////////////
