#!/bin/sh
#//////////////////////////////////////////////////////////////////
#// 
#//------------------------------------------------------------
#// Copyright(c) 2008: Southwest Microwave,Inc.
#//------------------------------------------------------------
#// 
#// FILENAME:
#//    restoreDefaults.sh
#//
#// PURPOSE:
#//    bourne shell script to restore Intrepid-II CM
#//    log file to factory default values
#//
#////////////////////////////////////////////////////////////////////

#/////////////////////////////////////////////////////////////////////
#// local variables
#/////////////////////////////////////////////////////////////////////
newLogFilename="/smi/log/smiCmLog.data"
bkupLogFilename="/smi/log/smiCmLog.data.bkup"
defaultLogFilename="/smi/log/smiCmLog.def"

#////////////////////////////////////////////////////////////////////
#// create new timestamp  
#////////////////////////////////////////////////////////////////////
newDateTime="Today is `date`"
echo "$newDateTime"

#////////////////////////////////////////////////////////////////////
#// replace banner strings
#////////////////////////////////////////////////////////////////////
    if [ -f $newLogFilename ]
    then
	echo "Archiving previous log file..."
	mv $newLogFilename $bkupLogFilename
    fi

    cat $defaultLogFilename | sed -e 's/smiCmLog.def/smiCmLog.data/' > temp1
    cat temp1 | sed -e "s/Today is /$newDateTime /" > temp2
        mv temp2 $newLogFilename
        rm temp1
        chmod 777 $newLogFilename
	if [ -f $bkupLogFilename ]
        then
            chmod 777 $bkupLogFilename
        fi

echo "Restoration completed...bye now"
#////////////////////////////////////////////////////////////////
# end
#////////////////////////////////////////////////////////////////
