<?php

class cmIpp2 {

// config variables

var $version = '';
var $port1_start_addr = '';
var $port1_end_addr = '';
var $port2_start_addr = '';
var $port2_end_addr = '';
var $cm_fault_tolerance = '';

var $ipp2_port1_minDstAddr;
var $ipp2_port1_maxDstAddr;
var $ipp2_port2_minDstAddr;
var $ipp2_port2_maxDstAddr;

var $display_vars;
var $customer_vars;
var $customer_var_errors;
var $customer_var_haserrors = FALSE;

var $newfile = array(); // FIXME KILL ME

var $params = 
	Array
		(
			'version'               => array('/^[0-9]+\.[0-9]+\.[0-9]+$/',NULL,NULL,FALSE),
			'ipp2_port1_minDstAddr' => array('/^[0-9]+$/',0,256,FALSE),
			'ipp2_port1_maxDstAddr' => array('/^[0-9]+$/',0,256,FALSE),
			'ipp2_port2_minDstAddr' => array('/^[0-9]+$/',0,256,FALSE),
			'ipp2_port2_maxDstAddr' => array('/^[0-9]+$/',0,256,FALSE),
			'cm_fault_tolerance'    => array('/^[0-9]+$/',0,256,FALSE),
			'apache_port'           => array('/^[0-9]+$/',0,65535,FALSE)
		);



function cmIpp2() {
	global $ref;
	$this->ipp2_port1_minDstAddr =& $this->port1_start_addr;
	$this->ipp2_port1_maxDstAddr =& $this->port1_end_addr;
	$this->ipp2_port2_minDstAddr =& $this->port2_start_addr;
	$this->ipp2_port2_maxDstAddr =& $this->port2_end_addr;
	$this->readDataFile($ref->smiCmIpp2);
}



function validParam($p,$v) {
	if(!isset($this->params[$p])) {
		return(FALSE);
	}
	if((strlen($this->params[$p][0]) > 0) && (preg_match($this->params[$p][0],$v) != 1)) {
		return(FALSE);
	}
	if(($this->params[$p][3] !== FALSE) && ($v == $this->params[$p][3])) {
		return(TRUE);
	}
	if(($this->params[$p][1] !== NULL) && ($this->params[$p][2] !== NULL) && 
		($v < $this->params[$p][1] || $v > $this->params[$p][2])
	) {
		return(FALSE);
	}
	return(TRUE);
}



function readDataFile($file) {

	global $ref;
	global $message;

	$fh = fopen($file,'r');
	if(!$fh) {
		$message->add('CmIpp2',"Could not open file $fn");
		return(FALSE);
	}
	$fail = FALSE;
	while(!feof($fh)) {
		$l = trim(fgets($fh));
		if($l{0} == '#') {
			continue;
		}
		if(strlen($l) <= 0) {
			continue;
		}
		if(strpos($l,'=') === FALSE) { 
			$fail = 'no = on line '.$l; 
			break; 
		}
		if((list($var,$val) = @explode('=',$l)) === FALSE) {
			$fail = 'no = on line '.$l; 
			continue;
		}
		$var = trim($var);
		$val = trim($val,"\" \t\n");
		if(!$this->validParam($var,$val)) { 
			$fail = 'no valid parameter on line '.$l; 
			break; 
		}
		if(isset($this->$var)) {
			$this->$var = $val;
			if(strpos($var,'version') !== FALSE) {
				$this->customer_vars[$var] =& $this->$var;
			}
		}
	}
	fclose($fh);
	if($fail !== FALSE) {
		$message->add('CmIpp2',"Could not parse file $file, $fail");
		return(FALSE);
	}
	return(TRUE);
}



function writeDataFileFromPOST() {

	global $ref;

	if(!isset($_POST['submit'])) {
		return(FALSE);
	}

	$this->port1_start_addr = intval(ereg_replace('[^0-9]','',$_POST['port1_start_addr']));
	$this->port1_end_addr = intval(ereg_replace('[^0-9]','',$_POST['port1_end_addr']));
	$this->port2_start_addr = intval(ereg_replace('[^0-9]','',$_POST['port2_start_addr']));
	$this->port2_end_addr = intval(ereg_replace('[^0-9]','',$_POST['port2_end_addr']));
	$this->cm_fault_tolerance = intval(ereg_replace('[^0-9]','',$_POST['cm_fault_tolerance']));

	$fh = fopen($ref->smiCmIpp2,'r');
	if(!$fh) {
		$this->makeMessage("Could not open configuration file '".$ref->smiCmIpp2."'");
		return(FALSE);
	}

	$newfile = array();
	$nodupe = FALSE;
	while(!feof($fh)) {
		$l = trim(fgets($fh));

		if(strpos($l,'#') !== FALSE) {
			$newfile[] = $l;
			$nodupe = FALSE;
			continue;
		}
		if(strlen($l) <= 0) {
			if(!$nodupe) {
				$newfile[] = '';
				$nodupe = TRUE;
			}
			continue;
		}
		if(strpos($l,'version') !== FALSE) {
			$newfile[] = 'version= '.$this->version." ";
			$newfile[] = 'ipp2_port1_minDstAddr= '.$this->port1_start_addr." ";
			$newfile[] = 'ipp2_port1_maxDstAddr= '.$this->port1_end_addr." ";
			$newfile[] = 'ipp2_port2_minDstAddr= '.$this->port2_start_addr." ";
			$newfile[] = 'ipp2_port2_maxDstAddr= '.$this->port2_end_addr." ";
			$newfile[] = 'cm_fault_tolerance= '.$this->cm_fault_tolerance." ";
			break;
		}
	}
	fclose($fh);

	$tmpfilename = $ref->smiCmIpp2.".tmp";
	$tmpfile = fopen($tmpfilename,'w');
	if(!$tmpfile) {
		$this->makeMessage("Could not open configuration file for write '$tmpfilename'");
		return(FALSE);
	}
	foreach($newfile as $ln => $line) {
		fputs($tmpfile,$line."\n");
	}
	fclose($tmpfile);

	if(system("mv $tmpfilename ".$ref->smiCmIpp2) === FALSE) {
		$this->makeMessage("Could not move $tmpfilename to ".$ref->smiCmIpp2.".  I need to do this to replace the configuration file.");
		return(FALSE);
	}

	return(TRUE);
}


}
