<?php
class cmLan {
// FIXME: rigorously test fail and error conditions

// internal variables
var $smiCmLanCtime;
var $smiCmLanBuCtime;
var $existsBackup = FALSE;
var $version;
var $ethernet_device;
var $ethernet_ipAddr;
var $ethernet_network;
var $ethernet_subnetmask;
var $ethernet_gateway;
var $ethernet_broadcast;
var $ethernet_domain_name;
var $ethernet_dns_addr1;
var $ethernet_dns_addr2;
var $ethernet_host_name;
var $ethernet_ip_family;
var $ethernet_ip_addr_type;
var $ethernet_http_port;

var $customer_vars;
var $customer_variables;
var $customer_var_errors;
var $customer_var_haserrors = FALSE;

var $params =
	Array
		(
			'version'               => array('/^[0-9]+\.[0-9]+\.[0-9]+$/',NULL,NULL,FALSE),
			'ethernet_device'       => array('/^eth[0-9]$/',NULL,NULL,FALSE),
			'ethernet_ipAddr'       => array('/^[0-9]{1,3}(\.[0-9]{1,3}){3}$/',NULL,NULL,FALSE),
			'ethernet_network'      => array('/^[0-9]{1,3}(\.[0-9]{1,3}){3}$/',NULL,NULL,FALSE),
			'ethernet_subnetmask'   => array('/^[0-9]{1,3}(\.[0-9]{1,3}){3}$/',NULL,NULL,FALSE),
			'ethernet_gateway'      => array('/^[0-9]{1,3}(\.[0-9]{1,3}){3}$/',NULL,NULL,FALSE),
			'ethernet_broadcast'    => array('/^[0-9]{1,3}(\.[0-9]{1,3}){3}$/',NULL,NULL,FALSE),
			'ethernet_domain_name'  => array('/^[a-zA-Z][a-zA-Z0-9]{0,62}(\.[a-zA-Z][a-zA-Z0-9]{0,62})*$/',NULL,NULL,FALSE),
			'ethernet_dns_addr1'    => array('/^[0-9]{1,3}(\.[0-9]{1,3}){3}$/',NULL,NULL,FALSE),
			'ethernet_dns_addr2'    => array('/^[0-9]{1,3}(\.[0-9]{1,3}){3}$/',NULL,NULL,FALSE),
			'ethernet_host_name'    => array('/^[a-zA-Z][a-zA-Z0-9]{0,62}(\.[a-zA-Z][a-zA-Z0-9]{0,62}){0,3}$/',NULL,NULL,FALSE),
			'ethernet_ip_family'    => array('/^IPV[46]$/',NULL,NULL,FALSE),
			'ethernet_ip_addr_type' => array('/^(static|dhcp)$/',NULL,NULL,FALSE),
			'ethernet_http_port'    => array('/^[0-9]{1,6}$/',NULL,NULL,FALSE),
			'ip_address'            => array('/^[0-9]{1,3}(\.[0-9]{1,3}){3}$/',NULL,NULL,FALSE)
		);




function cmLan() {
	global $ref;
	$this->getSmiCmLanDataCtime();
	$this->getSmiCmLanDataBuCtime();
	$this->readDataFile($ref->smiCmLan);
}



function validParam($p,$v) {
	if(!isset($this->params[$p])) {
		return(FALSE);
	}
	if((strlen($this->params[$p][0]) > 0) && (preg_match($this->params[$p][0],$v) != 1)) {
		return(FALSE);
	}
	if(($this->params[$p][3] !== FALSE) && ($v == $this->params[$p][3])) {
		return(TRUE);
	}
	if(($this->params[$p][1] !== NULL) && ($this->params[$p][2] !== NULL) && 
		($v < $this->params[$p][1] || $v > $this->params[$p][2])
	) {
		return(FALSE);
	}
	return(TRUE);
}



function prepareBackupView() {
	global $ref;
	$this->readDataFile($ref->smiCmLanBu);
}



function submitChanges() {
	global $ref;
	$this->readDataFile($ref->smiCmLan);
	$success = $this->writeDataFileFromPOST();
	$this->getSmiCmLanDataCtime();
	$this->getSmiCmLanDataBuCtime();
	if($success) { $this->readDataFile($ref->smiCmLan); }
	return($success);
}



function backup() {
    $this->backupConfig();
	$this->getSmiCmLanDataCtime();
	$this->getSmiCmLanDataBuCtime();
}



function restore() {
	$this->restoreFromBackup();
	$this->getSmiCmLanDataCtime();
	$this->getSmiCmLanDataBuCtime();
}



function getSmiCmLanDataCtime() {
	global $ref;
	if(file_exists($ref->smiCmLan)) {
		$this->smiCmLanCtime = date("F d, Y H:i:s.", filectime($ref->smiCmLan));
		return(TRUE);
	}
	$this->smiCmLanCtime = ERROR_NO_CM_LAN;
	return(FALSE);
}



function getSmiCmLanDataBuCtime() {
	global $ref;
	if(file_exists($ref->smiCmLanBu)) {
		$this->smiCmLanBuCtime = date("F d, Y H:i:s.", filectime($ref->smiCmLanBu));
		$this->existsBackup = TRUE;
		return(TRUE);
	} 
	$this->smiCmLanBuCtime = ERROR_NO_BACKUP;
	$this->existsBackup = FALSE;
	return(FALSE);
}



function readDataFile($file,$force=FALSE) {
	global $ref;
	global $message;

	$fh = fopen($file,'r');
	if(!$fh) {
		$message->add('cmLan',sprintf(ERROR_COULD_NOT_OPEN_FILE,$file));
		return(FALSE);
	}

	$fail = FALSE;
	while(!feof($fh)) {
		$l = trim(fgets($fh));
		if($l{0} == '#') {
			continue;
		}
		if(strlen($l) <= 0) {
			continue;
		} 
		if(strpos($l,'=') === FALSE) { 
			$fail = "no = on $var"; 
			break; 
		}
		list($var,$val) = @explode('=',$l);
		$var = trim($var);
		$val = trim($val," \t\n\"");
		if(!$this->validParam($var,$val)) { 
			$fail = "no valid parameter on $var."; 
			if(!$force) { break; }
		}
		$this->$var = $val;
		if(strpos($var,'ethernet') === 0) {
			$this->customer_vars[$var] =& $this->$var;
		}
	}
	fclose($fh);

	$this->customer_variables['Address Type'] =& $this->ethernet_ip_addr_type; 
		// H4X! hook in network/content.php, grep for "Address Type"
	$this->customer_variables['IP Address of CM-II'] =& $this->ethernet_ipAddr;
	$this->customer_variables['Network Address'] =& $this->ethernet_network;
	$this->customer_variables['Subnet Mask'] =& $this->ethernet_subnetmask;
	$this->customer_variables['Broadcast IP Address'] =& $this->ethernet_broadcast;
	$this->customer_variables['Gateway IP Address'] =& $this->ethernet_gateway;
	$this->customer_variables['Domain Name Server 1'] =& $this->ethernet_dns_addr1;
	$this->customer_variables['Domain Name Server 2'] =& $this->ethernet_dns_addr2;
//	$this->customer_variables['Domain Name of CM-II'] =& $this->ethernet_domain_name; // No changing domain name for now
	$this->customer_variables['Hostname of CM-II'] =& $this->ethernet_host_name;
	$this->customer_variables['Webserver port address'] =& $this->ethernet_http_port;

/* TRANSLATOR: Please use the same translation for CM-II as declared elsewhere */
	IP;
    NETWORK_ADDRESS;
    SUBNET_MASK;
    BROADCAST;
    GATEWAY;
    DNS1;
    DNS2;
/* TRANSLATOR: Please use the same translation for CM-II as declared elsewhere */
    DOMAIN;
/* TRANSLATOR: Please use the same translation for CM-II as declared elsewhere */
    HOSTNAME;
	WEBSERVER_PORT;

	if($fail !== FALSE) {
		$message->add('cmLan',"Could not parse cmlan file, $fail.");
		return(FALSE);
	}
	return(TRUE);
}



function writeDataFileFromPOST() {
	global $ref;
	global $message;

	$this->customer_var_haserrors = FALSE;
	foreach($this->customer_variables as $var => $val) {
		$val = addslashes(trim($_POST[str_replace(' ','_',$var)]));
		$this->customer_variables[$var] = $val;
		$this->error_correct($var,$val);
	}

	$file = fopen($ref->smiCmLan,'r');
	if(!$file) {
		$message->add('cmLan',sprintf(ERROR_COULD_NOT_OPEN_FILE,$ref->smiCmLan));
		return(FALSE);
	}

	$newfile = array();
	$nodupe = FALSE;
	while(!feof($file)) {
		$l = trim(fgets($file),"\n");

		if(strpos($l,'#') !== FALSE) {
			$newfile[] = $l."\n";
			$nodupe = FALSE;
			continue;
		}
		if(strlen(trim($l)) < 1) {
			if(!$nodupe) {
				$newfile[] = "\n";
				$nodupe = TRUE;
			}
			continue;
		}
		if((list($var,$val) = @explode('=',$l)) === FALSE) {
			$newfile[] = $l."\n";
			$nodupe = FALSE;
			continue;
		}
		if(strpos($var,'ethernet') === FALSE) {
			$newfile[] = $l."\n";
			$nodupe = FALSE;
			continue;
		}
		$var = trim($var);
		$val = trim($val);
		if(!isset($this->customer_vars[$var])) {
			$newfile[] = $l."\n";
			$nodupe = FALSE;
			continue;
		}
		$newfile[] = $var."= ".$this->customer_vars[$var]." \n";  // OMG H4X!!
		$nodupe = FALSE;
	}
	fclose($file);
	if($this->customer_var_haserrors) {
		$message->add('cmLan',ERROR_ERRORS_NO_CHANGES);
		return(FALSE);
	}

	$tmpfilename = $ref->smiCmLan.".tmp";
	$tmpfile = fopen($tmpfilename,'w');
	if(!$tmpfile) {
		$message->add('cmLan',sprintf(ERROR_FILE_NOT_WRITEABLE,$tmpfilename));
		return(FALSE);
	}
	foreach($newfile as $ln => $line) {
		fputs($tmpfile,$line);
	}
	fclose($tmpfile);

	if(system("mv $tmpfilename ".$ref->smiCmLan) === FALSE) {
		$message->add('cmLan',sprintf(ERROR_COULD_NOT_MOVE_CONFIG,$tmpfilename,$ref->smiCmLan));
		return(FALSE);
	}

	if(!$this->commitDatafileToNetwork()) {
		$message->add(
			NETWORK,
			sprintf(ERROR_NETWORK_SETTINGS,$ref->smiCmLan)
		);
		return(FALSE);
	}
	$message->add(
		/* TRANSLATOR: placed before a string to indicate they are getting a message from the Network page */ 
		NETWORK,
		NETWORK_UPDATED
	);
	return(TRUE);
}



function commitDatafileToNetwork() {
	global $ref;
	global $message;
	$e = array();
	exec($ref->smiMkEth0,$e,$s);
	if($s === 0) {
		exec($ref->smiReboot);
		return(TRUE);
	}
	if(count($e) > 0) {
		foreach($e as $k=>$l) {
			$message->add('cmLan',$l);
		}
	}
	return(FALSE);
}



function error_correct($var,$val) {
	$this->customer_var_errors[$var] = '';
	
	if(strcmp($var,'IP Address of CM-II') == 0) {
		if($this->ec_blank($val) || !$this->ec_ipaddress($val)) { 
			$this->customer_var_errors[$var] = ERROR_IP_ADDRESS;
			$this->customer_var_haserrors = true;
		}
		return;
	}
	if(strcmp($var,'Network Address') == 0) {
		if($this->ec_blank($val) || !$this->ec_ipaddress($val)) { 
			$this->customer_var_errors[$var] = ERROR_IP_ADDRESS;
			$this->customer_var_haserrors = true;
		}
		return;
	}
	if(strcmp($var,'Subnet Mask') == 0) {
		if($this->ec_blank($val) || !$this->ec_ipaddress($val)) { 
			$this->customer_var_errors[$var] = ERROR_SUBNET_MASK;
			$this->customer_var_haserrors = true;
		}
		return;
	}
	if(strcmp($var,'Broadcast IP Address') == 0) {
		if($this->ec_blank($val) || !$this->ec_ipaddress($val)) { 
			$this->customer_var_errors[$var] = ERROR_IP_ADDRESS;
			$this->customer_var_haserrors = true;
		}
		return;
	}
	if(strcmp($var,'Gateway IP Address') == 0) {
		if($this->ec_blank($val) || !$this->ec_ipaddress($val)) { 
			$this->customer_var_errors[$var] = ERROR_IP_ADDRESS;
			$this->customer_var_haserrors = true;
		}
		return;
	}
	if(strcmp($var,'Domain Name Server 1') == 0) {
		if($this->ec_blank($val) || !$this->ec_ipaddress($val)) { 
			$this->customer_var_errors[$var] = ERROR_IP_ADDRESS;
			$this->customer_var_haserrors = true;
		}
		return;
	}
	if(strcmp($var,'Domain Name Server 2') == 0) {
		if($this->ec_blank($val) || !$this->ec_ipaddress($val)) { 
			$this->customer_var_errors[$var] = ERROR_IP_ADDRESS;
			$this->customer_var_haserrors = true;
		}
		return;
	}
	if(strcmp($var,'Domain Name of CM-II') == 0) {
		if($this->ec_blank($val) || !$this->ec_domain($val)) {
			$this->customer_var_errors[$var] = ERROR_DOMAIN_NAME;
			$this->customer_var_haserrors = true;
		}
		return;
	}
	if(strcmp($var,'Hostname of CM-II') == 0) {
		if($this->ec_blank($val) || !$this->ec_hostname($val)) {
			$this->customer_var_errors[$var] = ERROR_HOSTNAME;
			$this->customer_var_haserrors = true;
		}
		return;
	}
	if(strcmp($var,'Webserver port address') == 0) {
		if(!$this->ec_apacheport($val)) {
			$this->customer_var_errors[$var] = ERROR_PORT;
			$this->customer_var_haserrors = true;
		}
		return;
	}
}

function ec_ipaddress($val) {
	if(!$this->validParam('ip_address',$val)) {
		return(FALSE);
	}
	$a = explode('.',$val);
	if(count($a) != 4) {
		return(FALSE); 
	}
	foreach($a as $k => $v) {
		if(!is_numeric($v) || $v < 0 || $v > 255) {
			return(FALSE);
		}
	}
	return(TRUE);
}

function ec_blank($val) {
	if(strlen(trim($val)) > 0) {
		return(FALSE);
	} else {
		return(TRUE);
	}
}

function ec_domain($val) {
	if(!$this->validParam('ethernet_domain_name',$val)) {
		return(FALSE);
	}
	return(TRUE);
}

function ec_hostname($val) {
	if(!$this->validParam('ethernet_host_name',$val)) {
		return(FALSE);
	}
	return(TRUE);
}

function ec_apacheport($val) {
	if(!is_numeric($val) || $val < 8080 || $val > 8089) {
		return(FALSE);
	}
	return(TRUE);
}

function backupConfig() {
	global $ref;
	global $message;
	if(system('cp '.$ref->smiCmLan.' '.$ref->smiCmLanBu) === FALSE) {
		$message->add('cmLan','Could not back up file '.$ref->smiCmLan.' to file '.$ref->smiCmLanBu);
		return(FALSE);
	}
	$message->add(NETWORK,BACKUP_STORED);
	return(TRUE);
}

function restoreFromBackup() {
	global $ref;
	global $message;
	if(system('cp '.$ref->smiCmLanBu.' '.$ref->smiCmLan) === FALSE) {
		$message->add('cmLan','Could not copy backup file '.$ref->smiCmLanBu.' to file '.$ref->smiCmLan);
		return(FALSE);
	}
	$this->getSmiCmLanDataCtime();
	$this->readDataFile($ref->smiCmLan);
	if(!$this->commitDatafileToNetwork()) {
		$message->add('cmLan',"While trying to restore from backup, could not update the network settings from file ".$this->smiCmLan);
		return(FALSE);
	}
	$message->add(NETWORK,NETWORK_RESTORED);
	return(TRUE);
}

}
?>
