<?php

global $page;
global $subpage;
global $ref;
global $hash;

require_once("cmipp2.class.php");
require_once("device.class.php");
require_once("zone.class.php");

//print_r($_POST);

if(!isset($_POST['s'])) {
	if(isset($_GET['s'])) { 
	    $_POST['s'] = $_GET['s'];
	} else {
	    $_POST['s'] = 0; 
	}
}

$cmipp2 = new cmIpp2;
$device = new Devices;
$zones = new Zones;

$timeconstant = 0.42;
$getstring = '';

$_POST['port1_start_addr'] = isset($_POST['port1_start_addr']) ? $_POST['port1_start_addr'] : $cmipp2->port1_start_addr;
$_POST['port1_end_addr'] =	isset($_POST['port1_end_addr']) ? $_POST['port1_end_addr'] : $cmipp2->port1_end_addr;
$_POST['port2_start_addr'] = isset($_POST['port2_start_addr']) ? $_POST['port2_start_addr'] : $cmipp2->port2_start_addr;
$_POST['port2_end_addr'] = isset($_POST['port2_end_addr']) ? $_POST['port2_end_addr'] : $cmipp2->port2_end_addr;
$_POST['cm_fault_tolerance'] = isset($_POST['cm_fault_tolerance']) ? $_POST['cm_fault_tolerance'] : 
	($cmipp2->cm_fault_tolerance ? 1 : 0);
$_POST['port2_start_addr'] = $_POST['cm_fault_tolerance'] == 0 ? $_POST['port2_start_addr'] : 0;
$_POST['port2_end_addr'] = $_POST['cm_fault_tolerance'] == 0 ? $_POST['port2_end_addr'] : 0;
$_POST['ftprevious'] = isset($_POST['ftprevious']) ? $_POST['ftprevious'] : 0;


$fail = FALSE;
$errormessage = '';
switch($_POST['s']){
case 0:		// pre-discovery check (not used)
case 10:	// start page


break;
case 100:	// Start Discovery
// Range check for COM2 and COM3 ports, snap to proper range and re-confirm with user
// This code only executes if javascript is off 

if($_POST['port1_start_addr'] < 0) {
	$_POST['port1_start_addr'] = 0;
	$fail = TRUE;
}
if($_POST['port1_end_addr'] > 239) {
	$_POST['port1_end_addr'] = 239;
	$fail = TRUE;
}
if($_POST['port2_start_addr'] < 0) {
	$_POST['port2_start_addr'] = 0;
	$fail = TRUE;
}
if($_POST['port2_end_addr'] > 239) {
	$_POST['port2_end_addr'] = 239;
	$fail = TRUE;
}
if($_POST['port1_start_addr'] > $_POST['port1_end_addr']) {
	$tmp = $_POST['port1_start_addr'];
	$_POST['port1_start_addr'] = $_POST['port1_end_addr'];
	$_POST['port1_end_addr'] = $tmp;
	$fail = TRUE;
}
if($_POST['port2_start_addr'] > $_POST['port2_end_addr']) {
	$tmp = $_POST['port2_start_addr'];
	$_POST['port2_start_addr'] = $_POST['port2_end_addr'];
	$_POST['port2_end_addr'] = $tmp;
	$fail = TRUE;
}
if($_POST['cm_fault_tolerance'] != $_POST['ftprevious']) {
	$_POST['s'] = 10;
	if(strlen($errormessage) > 0) { $errormessage .= '<br/>'; }
	$errormessage .= 'You have changed the fault tollerant mode, please select your address ranges now.';
}
if($fail) {
	$_POST['s'] = 10;
	if(strlen($errormessage) > 0) { $errormessage .= '<br/>'; }
	$errormessage .= 'Addresses fell outside of the [0-239] range.  Please confirm the address ranges you would like check.';
}

$getstring  = '?PHPSESSID='.$_COOKIE['PHPSESSID']; 
$getstring .= '&hash='.$hash;
$getstring .= '&ft='.$_POST['cm_fault_tolerance'];
$getstring .= '&port1_start_addr='.$_POST['port1_start_addr'];
$getstring .= '&port1_end_addr='.$_POST['port1_end_addr'];
if(!$_POST['cm_fault_tolerance']) {
	$getstring .= '&port2_start_addr='.$_POST['port2_start_addr'];
	$getstring .= '&port2_end_addr='.$_POST['port2_end_addr'];
}

if($_POST['s'] == 100){
	$cmipp2->port1_start_addr = $_POST['port1_start_addr']; 
	$cmipp2->port1_end_addr = $_POST['port1_end_addr']; 
	$cmipp2->port2_start_addr = $_POST['port2_start_addr']; 
	$cmipp2->port2_end_addr = $_POST['port2_end_addr']; 
	$cmipp2->cm_fault_tolerance = $_POST['cm_fault_tolerance'];
	$cmipp2->writeDataFileFromPOST();
}

break;
case 101:	// Accept or reject page
	$device->readDiscoveryFiles();
	$device->getCurrentStatus();
	if(md5_file($ref->newDevices) != md5_file($ref->currDevices))
	{
		$_SESSION['time_warning'] = DEVICES_CHANGED;
	}
	else
	{
		// JUST IN CASE CLEANUP
		unset($_SESSION['time_warning']);
	}
	break;

case 201:	// Accept Discovery
case 202:	// Reject Discovery
	$getstring  = '?PHPSESSID='.$_COOKIE['PHPSESSID'];
	$getstring .= '&hash='.$hash;
break;

case 301:	// Discovered Devices Accepted
	
// putting this into the conditional below did bad things
// an optimization has been placed into the expensive 
// updateZoneStates() command to ignore zones that are 
// DISABLED_UNASSIGNED
// Look at possibly using the conditional

	$device->readDiscoveryFiles();
	$device->newDisc2Device();
	$device->writeDeviceFiles();
	$zones->updateZoneStates();		

	if($_SESSION['fewer_found'])
	{
		// there could be the case that the number of devices found 
		// is the same but the devices have changed 
		// (ie. 1 added & 1 deleted)
		
		//$zones->cleanupZoneDevices($device->newDiscovery);
		unset($_SESSION['fewer_found']);
	}

	//$zones->cleanupZoneDevices($device->newDiscovery);

	if(isset($_SESSION['time_warning']))
	{
//		echo "TRIPPED MD5 FAILURE CASE";		
		unset($_SESSION['time_warning']);
	}
	else
	{
//		echo "DID NOT TRIP MD5 FAILURE";
	}


	break;
case 311:	
	$device->readinDevices();
	break;

case 302:	// Discovered Devices Rejected
case 312:
	$device->readinDevices();
	$device->readDiscoveryFiles();
	$device->getCurrentStatus();
	
	unset($_SESSION['time_warning']);
	
	break;
}


?>
<script language="JavaScript" type="text/javascript" >
<!--

function warnTime()
{
	var warnThreshold = 32;
	if(	document.getElementById('port1_end_addr').value - document.getElementById('port1_start_addr').value > warnThreshold ||
		document.getElementById('port2_end_addr').value - document.getElementById('port2_start_addr').value > warnThreshold)
	{
		alert('<?=LARGE_ADDRESS_RANGE?>');
		return false;
	}
}

function calculateRunTime() 
{
	var ipp2_port1_seconds;
	var ipp2_port2_seconds;
	var totalseconds;
	var temp;
	var cm_fault_tolerance;

	document.getElementById('port1_start_addr').value =
		 document.getElementById('port1_start_addr').value.replace(/[^0-9]/g,'').replace(/^$/,'0');
	document.getElementById('port1_end_addr').value =
		 document.getElementById('port1_end_addr').value.replace(/[^0-9]/g,'').replace(/^$/,'0');
	document.getElementById('port2_start_addr').value =
		 document.getElementById('port2_start_addr').value.replace(/[^0-9]/g,'').replace(/^$/,'0');
	document.getElementById('port2_end_addr').value =
		 document.getElementById('port2_end_addr').value.replace(/[^0-9]/g,'').replace(/^$/,'0');

	cm_fault_tolerance = document.getElementById('cm_fault_tolerance_yes').checked;
	if(cm_fault_tolerance) { 
		document.getElementById('ipp2_port2_row').style.color = '#aaaaaa';
		document.getElementById('port2_start_addr').disabled = 'disabled';
		document.getElementById('port2_end_addr').disabled = 'disabled';
		document.getElementById('ftprevious').value = 1;
	} 
	else 
	{
		document.getElementById('ipp2_port2_row').style.color = '#000000';
		document.getElementById('port2_start_addr').disabled = '';
		document.getElementById('port2_end_addr').disabled = '';
		document.getElementById('ftprevious').value = 0;
	}

	if(parseInt(document.getElementById('port1_start_addr').value) < 0) 
	{
		document.getElementById('port1_start_addr').value = 0;
	}
	if(parseInt(document.getElementById('port1_end_addr').value) > 239) 
	{
		document.getElementById('port1_end_addr').value = 239;
	}
	if(parseInt(document.getElementById('port2_start_addr').value) < 0) 
	{
		document.getElementById('port2_start_addr').value = 0;
	}
	if(parseInt(document.getElementById('port2_end_addr').value) > 239) 
	{
		document.getElementById('port2_end_addr').value = 239;
	}
	if(parseInt(document.getElementById('port1_start_addr').value) > parseInt(document.getElementById('port1_end_addr').value))
	{
		temp = document.getElementById('port1_start_addr').value;
		document.getElementById('port1_start_addr').value = document.getElementById('port1_end_addr').value;
		document.getElementById('port1_end_addr').value = temp;
	}
	if(parseInt(document.getElementById('port2_start_addr').value) > parseInt(document.getElementById('port2_end_addr').value))
	{
		temp = document.getElementById('port2_start_addr').value;
		document.getElementById('port2_start_addr').value = document.getElementById('port2_end_addr').value;
		document.getElementById('port2_end_addr').value = temp;
	}

	ipp2_port1_seconds = Math.round(
		(cm_fault_tolerance ? 2 : 1)
		* ((document.getElementById('port1_end_addr').value
		- document.getElementById('port1_start_addr').value
		+ 1)
		* <?= $timeconstant ?>)
		);
	ipp2_port2_seconds = Math.round(
		(cm_fault_tolerance ? 0 : 1)
		* ((document.getElementById('port2_end_addr').value
		- document.getElementById('port2_start_addr').value
		+ 1)
		* <?= $timeconstant ?>)
		);
	totalseconds = ipp2_port1_seconds + ipp2_port2_seconds;
	document.getElementById('ipp2_port1_time').innerHTML = 
		Math.floor(ipp2_port1_seconds / 60) + ' <?= MINUTES ?> ' 
		+ Math.ceil(ipp2_port1_seconds % 60) + ' <?= SECONDS ?>';
	document.getElementById('ipp2_port2_time').innerHTML = 
		Math.floor(ipp2_port2_seconds / 60) + ' <?= MINUTES ?> ' 
		+ Math.ceil(ipp2_port2_seconds % 60) + ' <?= SECONDS ?>';
	document.getElementById('totaltime').innerHTML =
		Math.floor(totalseconds / 60) + ' <?= MINUTES ?> ' 
		+ Math.ceil(totalseconds % 60) + ' <?= SECONDS ?>';
<?
$ipp2_port1_seconds = round(($_POST['port1_end_addr'] - $_POST['port1_start_addr'] + 1) * $timeconstant * ($_POST['cm_fault_tolerance'] ? 2 : 1));
$ipp2_port2_seconds = round($_POST['cm_fault_tolerance'] ? 0 : ($_POST['port2_end_addr'] - $_POST['port2_start_addr'] + 1) * $timeconstant);
$totalseconds = $ipp2_port1_seconds + $ipp2_port2_seconds;
$ipp2_port1_time = floor($ipp2_port1_seconds / 60) . ' ' . MINUTES .', ' 
	. ceil($ipp2_port1_seconds % 60) . ' ' . SECONDS;
$ipp2_port2_time = floor($ipp2_port2_seconds / 60) . ' ' . SECONDS.', '
	. ceil($ipp2_port2_seconds % 60) . ' ' . SECONDS;
$totaltime = floor($totalseconds / 60) . ' ' . MINUTES.', '
	. ceil($totalseconds % 60) . ' ' .  SECONDS;
?>
}



-->
</script>

<? if($errormessage): ?>
<p>&nbsp;</p>
<div id="errormessage">
<?= $errormessage ?>
</div>
<? endif; ?>

<? if($message->count() > 0): ?>
		<div id="errormessage">
		<hr/>
<?= $message->dump() ?>
		<hr/>
		</div>
<? endif; ?>

<?=$button->breadcrumb(false)?>

<? // *** CAREFUL *** : switch statement must close the </h2> ?>
<? switch($_POST['s']): ?>
<? case 0: // start ?>

<? case 10: // Verify addresses defined ?>
</h2>
<div class="caution">
<p><strong><?= CANNOT_INTERRUPT_BEFORE ?>
<?=($device->getCurrentStatus(null, true) ? 
	'<br /><br /><blink>'. WARNING . ':</blink> '.ERROR_DEVICES_FOUND .' '.  ACCEPTING_FEWER_DEVICES
	:
	''
	)
?></strong></p>
</div>
<form class="button" method="POST" action="" onSubmit="pleaseWait();">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="100" />
<table>
<tr>
<td><input type="radio" name="cm_fault_tolerance" id="cm_fault_tolerance_no" value="0" 
<?= $_POST['cm_fault_tolerance']==0 ? ' checked="checked" ' : '' ?>
onClick="calculateRunTime();" onChange="calculateRunTime();"
/> <?=
/* TRANSLATOR: Field entry text before a radio button.
'Fault Tollerance' is a technical term in security systems.
Literally, the system tollerates a fault in the line and 
remains operational.
*/
NOT_FAULT_TOLLERANT
?> 
<input type="radio" name="cm_fault_tolerance" id="cm_fault_tolerance_yes" value="1" 
<?= $_POST['cm_fault_tolerance']==1 ? ' checked="checked" ' : '' ?>
onClick="calculateRunTime();" onChange="calculateRunTime();"
/> <?=
/* TRANSLATOR: Field entry text before a radio button.
'Fault Tollerance' is a technical term in security systems.
Literally, the system tollerates a fault in the line and 
remains operational.
*/
FAULT_TOLLERANT
?>
<input type="hidden" name="ftprevious" id="ftprevious" value="<?= $_POST['cm_fault_tolerance'] ?>" />
</td>
</tr>
<tr>
<td><?= 
/* TRANSLATOR: Text before a text entry field.
'Pollmaster' is a technical term in security systems.  It's the job
of the pollmaster to poll many devices on a wire to check the 
condition of the device, say to see if the device is broken or has
tripped an alarm.  The frequency is very high, several times per 
second.
*/
PORT_A
?>:
<?= 
/* TRANSLATOR: Text before a text entry field.
These are addresses of devices on a wire, the user enters a 
numerical value.
*/
START_ADDRESS
?>(0-239):
<input type="text" name="port1_start_addr" id="port1_start_addr" maxlength="3" size="3" value="<?= $_POST['port1_start_addr'] ?>" onChange="calculateRunTime(); warnTime();" />
<?=
/* TRANSLATOR: Text before a text entry field.
These are addresses of devices on a wire, the user enters a 
numerical value.
*/
END_ADDRESS
?>(0-239):
<input type="text" name="port1_end_addr" id="port1_end_addr" maxlength="3" size="3" value="<?= $_POST['port1_end_addr'] ?>" onChange="calculateRunTime(); warnTime();" />
</td>
<td>
<span id="ipp2_port1_time"><?= $ipp2_port1_time ?></span>
</td>
</tr>
<tr id="ipp2_port2_row" <?= $_POST['cm_fault_tolerance'] == 1 ? ' style="color:#aaaaaa"' : ''?>>
<td><?= 
/* TRANSLATOR: Text before a text entry field.
'Pollmaster' is a technical term in security systems.  It's the job
of the pollmaster to poll many devices on a wire to check the 
condition of the device, say to see if the device is broken or has
tripped an alarm.  The frequency is very high, several times per 
second.
*/
PORT_B
?>:
<?= 
START_ADDRESS
?>(0-239):
<input type="text" name="port2_start_addr" id="port2_start_addr" maxlength="3" size="3" 
	value="<?= $_POST['port2_start_addr'] ?>"
	<?= $_POST['cm_fault_tolerance'] == 1 ? ' disabled="disabled"' : ''?>
	onChange="calculateRunTime(); warnTime();" />
<?=
END_ADDRESS
?>(0-239):
<input type="text" name="port2_end_addr" id="port2_end_addr" maxlength="3" size="3" 
	value="<?= $_POST['port2_end_addr'] ?>"
	<?= $_POST['cm_fault_tolerance'] == 1 ? ' disabled="disabled"' : ''?>
	onChange="calculateRunTime(); warnTime();" />
</td>
<td>
<span id="ipp2_port2_time"><?= $ipp2_port2_time ?></span>
</td>
<tr>
<td style="text-align:right"><strong><?=
/* TRANSLATOR: Meaning, we display the number of minutes and seconds to the user here */
TOTAL_TIME
?>:</strong></td>
<td><b><span id="totaltime"><?= $totaltime ?></span></b></td>
</tr>
</table>
<br/>
<input class="submitbutton" type="submit" name="submit" value="<?=
/* TRANSLATOR: Button Text.  Starts the discovery process.
Very strongly emphasized with all capital letters, because 
this is a lengthy procedure.
*/
START
?>" />
</form>



<? break; ?>
<? case 100: ?>
 &raquo; <?= /* TRANSLATOR: Header Text */ NEW_DISCOVERY ?></h2>
<div class="caution">
<p><strong><?= CANNOT_INTERRUPT_DURING ?></strong></p>
<p><strong><?= KEEP_BROWSER_OPEN ?></strong></p>
<p><?= sprintf(POLLING, CM_II) ?></p>
<p><?= PORT_A ?>: <?= START_ADDRESS ?>: <?= $_POST['port1_start_addr'] ?> -- <?= END_ADDRESS ?>: <?= $_POST['port1_end_addr'] ?></p>
<p><?= PORT_B ?>: <?= START_ADDRESS ?>: <?= $_POST['port2_start_addr'] ?> -- <?= END_ADDRESS ?>: <?= $_POST['port2_end_addr'] ?></p>
<p><?= TIME_REQUIRED ?>: <strong><?= $totaltime ?></strong></p>
</div>
<p>
<iframe frameborder="0" src="/cgi-bin/StartDiscovery<?= $getstring ?>" name="Device Discovery Page" width="800" height="500">
<?= SELECT_DISCOVDERY_FRAME ?>
</iframe>
</p>

<? break; ?>
<? case 101: ?>
 &raquo; <?= /* TRANSLATOR: Header Text */ NEW_DEVICES_DISCOVERED ?></h2>

<? $_SESSION['fewer_found'] = false; ?>

<? if(count($device->currDiscovery) > count($device->newDiscovery)): ?>
<? $_SESSION['fewer_found'] = true; ?>
<p><strong color="red">
	<?= sprintf(FEWER_DEVICES_DISCOVERED)?>
</strong></p>
<? endif ?>

<? if(isset($_SESSION['time_warning'])): ?>
<p><strong color="red">
	<?= $_SESSION['time_warning'] ?>
</strong></p>
<? endif ?>

<? $device->getCurrDiscoveryStatus(); ?>

<table class="disc" id="discoveredDeviceList">
<? foreach(array(PREVIOUS_DEVICES => $device->currDiscovery, NEW_DEVICES => $device->newDiscovery) as $d => $t): ?>
<tr class="mainheader">
<th colspan="9"><?= $d ?></th>
</tr>
<tr>
<th><?= ADDRESS ?></th>
<th><?= TYPE ?></th>
<th><?= PORT ?></th>
<th><?= STATUS ?></th>
<th><?= NAME ?></th>
</tr>
<? if(count($t) <= 0): ?>
<tr><td colspan="9"><?= 
/* TRANSLATOR: Small result message.  There were no devices found, or there are no devices here now. */
NO_DEVICES
?></td></tr>
<? endif; ?>
<? foreach($t as $i => $a): ?>
<tr<?= $i%2 == 1 ? ' class="shaded"' : '' ?>>
<td><?= $a['nAddr'] ?></td>
<td><?= $a['ftypestring'] ?></td>
<td><?= constant(@$ref->portIdString[$a['ttyPort']]) ?></td>
<td><?= implode('<br/>',explode('|',constant(@$ref->deviceStatusString($a['devStatus'])))) ?></td>
<td><?= $a['tagName'] ?></td>
</tr>
<? endforeach; ?>
<tr><td>&nbsp;</td></tr>
<? endforeach; ?>
</table>

<p>
<form class="button" name="continue" method="POST" action="" onSubmit="pleaseWait();">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="201" />
<input type="hidden" name="maytaketime" value="<?=$_SESSION['time_warning'] ?>" />
<input class="submitbutton" type="submit" name="submit" value="<?=
/* TRANSLATOR: Button Text.  Accept a list of values to be correct or valid. */
ACCEPT
?>" />
</form>
<form class="button" name="continue" method="POST" action="" onSubmit="pleaseWait();">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="202" />
<input class="submitbutton" type="submit" name="submit" value="<?=
/* TRANSLATOR: Button Text.  Reject a list of values because they are incorrect. */
REJECT
?>" />
</form>
</p>

<? break; ?>
<? case 201: ?>
 &raquo; <?= /* TRANSLATOR: Header Text. */ ACCEPT_DISCOVERY ?></h2>

<p><strong><?= sprintf(
DISCOVERY_ACCEPTED,
CM_II, CM_II )
?></strong></p>

<? if(isset($_POST['maytaketime'])): ?>
<p><strong><?=$_POST['maytaketime']?>
</strong></p>
<? endif ?>

<p>
<iframe frameborder="0" src="/cgi-bin/AcceptDiscovery<?= $getstring ?>" name="Accept Discovery Page" width="800" height="500">
Select the Accept Discovery Page frame to continue.
</iframe>
</p>

<? break; ?>
<? case 202: ?>
 &raquo; <?= /* TRANSLATOR: Header Text. */ REJECT_DISCOVERY ?></h2>

<p><?= sprintf(ERROR_REJECTING_FOUND_DEVICES, CM_II, CM_II ) ?></p>

<p>
<iframe frameborder="0" src="/cgi-bin/RejectDiscovery<?= $getstring ?>" name="Reject Discovery Page" width="800" height="500">
<?= SELECT_REJECT_DISCOVERY_FRAME ?>
</iframe>
</p>

<? break; ?>
<? case 301: ?>
<? case 311: ?>
 &raquo; <?= /* TRANSLATOR: Header Text */ DISCOVERED_DEVICES_ACCEPTED ?></h2>

<p><strong><?= sprintf(DISCOVERED_DEVICES_ACCEPTED_POLLING, CM_II, CM_II) ?></strong></p>

<table class="disc">
<? foreach(array(CURRENT_DEVICES => $device->newDiscovery) as $d => $t): ?>
<tr class="mainheader">
<th colspan="9"><?= $d ?></th>
</tr>
<tr>
<th><?= ADDRESS ?></th>
<th><?= TYPE ?></th>
<th><?= PORT ?></th>
<th><?= STATUS ?></th>
<th><?= NAME ?></th>
</tr>
<? if(count($t) <= 0): ?>
<tr><td colspan="9"><?= NO_DEVICES ?></td></tr>
<? endif; ?>
<? foreach($t as $i => $a): ?>
<tr<?= $i%2 == 1 ? ' class="shaded"' : '' ?>>
<td><?= $a['nAddr'] ?></td>
<td><?= $a['ftypestring'] ?></td>
<td><?= constant(@$ref->portIdString[$a['ttyPort']]) ?></td>
<td><?= implode('<br/>',explode('|',constant(@$ref->deviceStatusString($a['devStatus'])))) ?></td>
<td><?= $a['tagName'] ?></td>
</tr>
<? endforeach; ?>
<tr><td>&nbsp;</td></tr>
<? endforeach; ?>
</table>

<? break; ?>

<? case 302: ?>
<? case 312: ?>
 &raquo; <?= /* TRANSLATOR: Header Text */ DISCOVERED_DEVICES_REJECTED ?></h2>

<p><strong><?= sprintf(DISCOVERED_DEVICES_REJECTED_POLLING, CM_II, CM_II) ?></strong></p>

<table class="disc">
<? foreach(array(CURRENT_DEVICES => $device->currDiscovery) as $d => $t): ?>
<tr class="mainheader">
<th colspan="9"><?= $d ?></th>
</tr>
<tr>
<th><?= ADDRESS ?></th>
<th><?= TYPE ?></th>
<th><?= PORT ?></th>
<th><?= STATUS ?></th>
<th><?= NAME ?></th>
</tr>
<? if(count($t) <= 0): ?>
<tr><td colspan="9"><?= NO_DEVICES ?></td></tr>
<? endif; ?>
<? foreach($t as $i => $a): ?>
<tr<?= $i%2 == 1 ? ' class="shaded"' : '' ?>>
<td><?= $a['nAddr'] ?></td>
<td><?= $a['ftypestring'] ?></td>
<td><?= constant(@$ref->portIdString[$a['ttyPort']]) ?></td>
<td><?= implode('<br/>',explode('|',constant(@$ref->deviceStatusString($a['devStatus'])))) ?></td>
<td><?= $a['tagName'] ?></td>
</tr>
<? endforeach; ?>
<tr><td>&nbsp;</td></tr>
<? endforeach; ?>
</table>

<? break; ?>
<? default: ?>
</h2>
<? endswitch; ?>

<p>&nbsp;</p>
