<?php

// UNCOMMENT NEXT LINE && UNCOMMENT APD EXTENSION IN PHP.INI TO ENABLE PAGE PROFILING
//apd_set_pprof_trace();

function print_a($item) { echo '<pre>'; print_r($item); echo '</pre>'; }

session_start();

$_SESSION['page_load_time'] = time();
//ob_start();

/* If a POST of 'hash' is made, then a session var of hash should
 * have also been set by the page that made the post.  If they don't
 * match then someone has hit the back button in a bad way, so
 * redirect to the home page.
 */

if(isset($_POST['hash']) && (!isset($_SESSION['hash']) || ($_SESSION['hash'] != $_POST['hash']))) {
	header('status: 303');
	header('Location: http://'.$_SERVER['HTTP_HOST'].'/');
	die();
}
$tsts = 'Nope.';
if(isset($_POST['hash'])) {
	$tsts = 'Yes, '.$_SESSION['hash'].' ?= '.$_POST['hash'];
}

srand(time());
$hash = $_SESSION['hash'] = ( rand(0,9999) );

$self = explode('/',$_SERVER["REQUEST_URI"]);
if(count($self)>2) {
	$page = $self[1];
	if(count($self)>3) {
		$subpage = $self[2];
	} else {
		$subpage = 'home';
	}
} else {
	$page = 'home';

}

require_once('reference.class.php');
$ref = new Reference;

if(!isset($_SESSION['device_version']))
{
	@exec('cat /smi/config/site/smiCmPartNbr.data | grep partNumber | awk \'{print $2}\'', $temp);
	$_SESSION['device_version'] = implode($temp, '');
	//print_r($temp);
}

require_once('message.class.php');
$message = new Message;
if(isset($_SESSION['Message'])) {
	$message = unserialize($_SESSION['Message']);
}
// $message->add('hash', $tsts);
// $message->add('hash', $_POST['hash'].' => '.$_SESSION['hash']);

require_once('locale.class.php');
$locale = new Locale;
if(isset($_POST['locale'])) {
	$locale->change($_POST['locale']);
	unset($_SESSION['define']);
}

$_SESSION['locale'] = $locale;

if(!empty($_SESSION['define']))
{
	foreach($_SESSION['define'] as $name => $val)
	{
		define($name, $val);
	}
}
else
{
	require_once('language_parser.class.php');
	$p = &new language_parser($locale->encoding_code);

	$result = $p->setInputFile('locale/'.$locale->language_code.'/lang.xml');
	$result = $p->parse();
}



putenv('LANG='.$locale->locale);
setlocale(LC_ALL, $locale->locale);
bindtextdomain('lang', $ref->smiCmLangDir );
textdomain('lang');
bind_textdomain_codeset('lang', $locale->locale);

require_once('login.class.php');
$login = new Login;
if(isset($_SESSION['Login'])) {
	$login = unserialize($_SESSION['Login']);
}
$login->prepage();
if($login->redirect() || !$login->authForThisPage($page)) {
	header('status: 303');
	header('Location: http://'.$_SERVER['HTTP_HOST'].'/');
	my_exit();
}
if(!$login->loggedin()
	&& !(strcmp($page,'home')===0)
	&& !(strcmp($page,'login')===0)
	&& !(strcmp($page,'logout')===0)
	&& !(strcmp($page,'shutdown')===0)
) {
	header('status: 303');
	header('Location: http://'.$_SERVER['HTTP_HOST'].'/logout/');
	my_exit();
}

require_once('site.class.php');
$site = new Site;

//require_once('timezone.class.php');
//$timezone = new TimeZone;

ob_start();
	@include 'http://'.$_SERVER['HTTP_HOST'].'/cgi-bin/CheckTestComms';
	$CheckTestComms = ob_get_contents();
ob_end_clean();

if($CheckTestComms == 0) // if currently running
{
	$_SESSION['testComms'] = true;

	if(strcmp($page,'testcomms')!==0
		&& (strcmp($page,'login')!==0)
		&& (strcmp($page,'logout')!==0)
		&& (strcmp($page,'shutdown')!==0)
	)
	{
		$message->add(
			TEST_COMMS,
			ERROR_TEST_COMMS_RUNNING);

		header('Location: http://'.$_SERVER['HTTP_HOST'].'/testcomms/');
		my_exit();
	}
}
else
{
	$_SESSION['testComms'] = false;
}


// This is the single exit point for this page.
// It is called at the end of the page, and
// should be called	any other place we desire
// to stop parsing and exit.
function my_exit() {
	global $login;
	global $message;
	$_SESSION['Login'] = serialize($login);
	$_SESSION['Message'] = serialize($message);
	exit();
}



header('Content-type: text/html;charset=<?= $locale->encoding_code ?>');
header('Content-Language: '.$locale->encoding_code);
//header('Cache-Control: no-cache');
//header('Pragma: no-cache');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">

<html lang="<?= $locale->locale ?>">
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=<?= $locale->encoding_code ?>" />
	<meta http-equiv="Content-Language" content="<?= $locale->encoding_code ?>" />
<!--
	<meta http-equiv="Cache-Control" CONTENT="no-cache" />
	<meta http-equiv="Pragma" CONTENT="no-cache" />
	<meta http-equiv="Expires" content="0" />
-->
<?= (strcmp($page,'site')===0 && strcmp($subpage,'name')===0 &&
	(isset($_POST['s']) && $_POST['s']==1 ))
	? "<meta http-equiv='refresh' content='0;url=/". $page ."/'>": ''; ?>
	<meta http-equiv="X-UA-Compatible" content="IE=EmulateIE7" />
<title>
<?=
/* TRANSLATOR: Southwest Microwave, Inc. is our company name.  Please
discuss our marketing department how this string should appear in this
language.
*/
SMI
?> : <?=
/* TRANSLATOR: Intrepid ™ is the official trademarked name of this set
of products.  Please discuss with our marketing department how this
string should appear in this langauge.
*/
INTREPID
?> : <?=
/* TRANSLATOR: Control Module II is the official name of this product.
Please discuss with our marketing department how this string should
appear in this langauge.
*/
CONTROL_MODULE_II;
/* TRANSLATOR: Control Module II is the official name of this product.
Please discuss with our marketing department how this abbreviated
string should appear in this langauge.
*/
CM_II;
?>
</title>
<link href="/style.css" rel="stylesheet" type="text/css" title="Default Southwest Microwave Style" media="screen,tv,tty,handheld,braille,aural,speech">
<link href="/printstyle.css" rel="stylesheet" type="text/css" title="Printer" media="print,projection">
<script language="JavaScript" type="text/javascript" src="/prototype.js"></script>
<script language="JavaScript" type="text/javascript" src="/xml.js"></script>

<?=	(strcmp($page,'zonecontrol')===0 && isset($_POST['s']) && ($_POST['s']==1 || $_POST['s']==2 || $_POST['s']==4) ?
		'<script language="JavaScript" type="text/javascript" src="/scriptaculous.js?load=slider"></script>' :
		''
) ?>
<script language="JavaScript" type="text/javascript" src="/cookie.js"></script>
<script language="JavaScript" type="text/javascript" >
<!--

<? if(!$login->loggedin()): ?>
if(window.history.length > 1) {
	window.history.forward(1);
}
<? endif ?>


browserDate = new Date();
hostPhpDate = new Date();
hostPhpDate.setTime(<?=time();?>*1000);
dateOffset = 0;

function startAll() {
<?
	if($page != 'home' && $page != 'logout') /*&& $login->loggedin())*/
	{
		echo 'menu_show(\''.$page.'\');'."\n";
		echo 'disable_all_but(\''.$page.'\');'."\n";
		echo 'add_ToTop_element(\''.$page.'\');'."\n";
		$show_menu_up = true;
	}
?>
}

<? if($page == 'login') : ?>
function clear_lock()
{
	var url = '/clearlock.php';
	new Ajax.Request(url,
			{
				method: 'POST',
				onSuccess: function(transport)
				{
					$('logout_area').innerHTML = "<strong>Lock Cleared</strong>";
				}
			});
}
<? endif ?>

function zeroNumeral(i) {
	if (i<10) {
		i ="0" + i;
	}
	return i
}

function UpdateImg(ctrl,imgsrc) {
	var swoosh_img = $(ctrl);
	swoosh_img.src = imgsrc;
}

function ie_swoosh_fix()
{
}

var img = new Image();
img.src="/swoosh.gif";

pleasewaitid = 'pleasewait';
pleasewaitstyle = '';
function pleaseWait(showTimeWarning) {

	var style = 'background-image:url(\'/swoosh.gif\');';
	style = style + 'background-repeat:repeat-x;';
	style = style + 'clear:left;';
	style = style + 'float:left;';
	style = style + 'width:97%;';
	style = style + 'height:700px;';
	style = style + 'overflow:hidden;';
	style = style + 'padding:0;';
	style = style + 'margin:0 0 0 1em;';
	style = style + pleasewaitstyle;

	/*var swoosh_html = '<img src="/swoosh.gif" id="swoosh_id" alt="" border="0" />';*/
	var wait_message = /*swoosh_html +*/ ((showTimeWarning == null) ? "&nbsp;" : "<?="<br /><br />" . PLEASE_WAIT ?>");

	var wait = '<div style="' + style + '"><p>' + wait_message + '</p></div>';
	var element = $(pleasewaitid);
	try { menu_show(); } catch(ex) {}
	try { element.innerHTML = wait; } catch(ex) { }
	try { $('mainbody').style.visibility = 'hidden'; } catch(ex) { }
	try { $('gn').style.visibility = 'hidden'; } catch(ex) { }
	try { $('errormessage').style.visibility = 'hidden'; } catch(ex) { }
	try {
			if (window.scrollBy)
			{
				window.scrollBy(0, window.innerHeight ? -window.innerHeight : -document.body.clientHeight);
			}
		} catch(ex) {}

/*	try{ setTimeout("UpdateImg('swoosh_id','/swoosh.gif');" , 50); } catch(ex) {} */
	return true;
}

function menu_show(parent_id)
{
	if($(parent_id) != null)
	{
		$(parent_id).style.background="url(/over_red.gif)";

		if($('C_'+parent_id) != null)
		{
			$('C_'+parent_id).style.display='block';
		}
	}

	for (i=0;i<divs.length;i++)
	{
		if(divs[i] == parent_id) /*&& $(parent_id) != null)*/
		{
/*
			$(parent_id).style.background="url(/over_red.gif)";

			if($('C_'+parent_id) != null)
			{
				$('C_'+parent_id).style.display='block';
			}
*/
		}
		else if($(divs[i]) != null)
		{
			$(divs[i]).style.background="url(/off_red.gif)";

			if($('C_'+divs[i]) != null)
			{
				$('C_'+divs[i]).style.display='none';
			}
		}
	}
}

function add_ToTop_element(id)
{
	try
	{
		var Parent = $('C_'+ id);
		var NewLI = document.createElement("UL");

		NewLI.innerHTML = '<li><h2><a onClick="menu_show(); pleaseWait(1);" href="/"><?= TO_MAIN_MENU ?></a></h2></li>';

		Parent.appendChild(NewLI);
	}
	catch(ex) {}
}

function disable_all_but(parent_id)
{
	for (i=0;i<divs.length;i++)
	{
		if(divs[i] == parent_id)
		{}
		else if($(divs[i]) != null)
		{
			$(divs[i]).style.color='#999999';
			$(divs[i]).onmouseover='';
			/*$(divs[i]).href='#';*/
		}
	}
}

function SetValues(event)
{
	var ev=(!event)?window.event:event;  //Moz:IE

	if (ev.pageX) { //Mozilla or compatible

		/* The absolute position of the control */
		var SUBMENU_Pos = GetAbsPosition($('gn_sub_outside'));

		/* Relative to this div */
		MousePointerDivX = ev.pageX-SUBMENU_Pos.x;
		MousePointerDivY = ev.pageY-SUBMENU_Pos.y;

		if(	MousePointerDivY > SUBMENU_Pos.cy ||
			MousePointerDivY <= 0 ||
			MousePointerDivX > SUBMENU_Pos.cx ||
			MousePointerDivX <= 0)
		{
			menu_show();
		}
	}
	else if(ev.clientX) { //IE or compatible

		/* Relative to this div */
		MousePointerDivX = window.event.x;
		MousePointerDivY = window.event.y;

		/* Relative to the top left of the viewable area */
		MousePointerClientX = window.event.clientX;
		MousePointerClientY = window.event.clientY;

		/* The absolute position of the control */
		var SUBMENU_Pos = GetAbsPosition(gn_sub_outside);

		// had to hard code the 25 instead of SUBMENU_Pos.cy because of some odd bug where value disappears
		if(	MousePointerClientY >= SUBMENU_Pos.cy + SUBMENU_Pos.y ||
			MousePointerClientY-1 <= SUBMENU_Pos.y ||
			MousePointerClientX-1 <= SUBMENU_Pos.x ||
			MousePointerClientX >= SUBMENU_Pos.cx + SUBMENU_Pos.x)
		{
			menu_show();
		}
	}
	else  //old browsers
	{
		return false;
	}

    setInterval("",20);
}

// Calculates the object's absolute position, and width and height
function GetAbsPosition(object) {

	var position = new Object;
	position.x = 0;
	position.y = 0;

	if( object ) {
		position.x = object.offsetLeft;
		position.y = object.offsetTop;

		if( object.offsetParent ) {
			var parentpos = GetAbsPosition(object.offsetParent);
			position.x += parentpos.x;
			position.y += parentpos.y;
		}
	}

	position.cx = object.offsetWidth;
	position.cy = object.offsetHeight;

	return position;
}

-->
</script>

</head>
<body
<?= (strcmp($page,'devicecontrol')===0 && (strcmp($subpage,'home')===0 ) ? 'name="rootDocument" id="rootDocument" ' : '') ?>
<?= (strcmp($page,'zonecontrol')===0 && (!isset($_POST['s']) || $_POST['s']===0) ? 'name="rootDocument" id="rootDocument" ' : '') ?>
onLoad="startAll();
<?= (strcmp($page,'filetransfer')===0 && strcmp($subpage,'backup')===0 &&
	(isset($_POST['s']) && $_POST['s']>0 ))
	? " document.getElementById('disappear').innerHTML = '&nbsp;'; " : '' ?>
<?= (strcmp($page,'devicecontrol')===0 && (strcmp($subpage,'home')===0 ) ? 'window.name=\'rootDocument\'; ' : '') ?>
<?=	(strcmp($page,'zonecontrol')===0 && isset($_POST['s']) && ($_POST['s']==1 || $_POST['s']==2 || $_POST['s']==4) ? 'startForm(); ' : '') ?>
<?= (strcmp($page,'filetransfer')===0 && strcmp($subpage,'defaults')===0 &&
	(isset($_POST['s']) && $_POST['s']==30 ))
	? "document.restartnow.submit(); document.getElementById('confirmupgrade').disabled = true; document.getElementById('confirmupgrade').style.visibility = 'hidden'; document.getElementById('swoosh').style.visibility = 'visible';" : '' ?>
">
<noscript>
<center><strong><blink><?= ERROR_CRITICAL ?></blink><?= /* TRANSLATOR: Message informing user that a web browser supporting JavaScript is required to continue. */ ERROR_JAVASCRIPT ?></strong></center>
<br /><br />
</noscript>
<script language="JavaScript" type="text/javascript" >
<? if($login->loggedin): ?>

		//function startBannerUpdate()
		//{
<? if(strcmp($page,'testcomms')!==0) : ?>
			var xslUrl_topbanner = '/topbannerXSL.php';
			var xslProcessor_topbanner = new XSLT(xslUrl_topbanner);

			var userName = '';
			var newTopBannerData = '';
			var newSystemDateData = '';

			new Ajax.PeriodicalUpdater('topbannerinfosection_hidden', '/cgi-bin/TopBanner',
										{
											method: 'POST',
											frequency: 1,
											onSuccess:function(transport)
											{

												// get the XML data
												try
												{
													var xmlTopBannerData = new XML(transport.responseXML);
												}
												catch (e)
												{
													alert(request.responseText);
												}

												// get the username out of the XML
												// userName = xmlTopBannerData.getNodeValue('//TOP_BANNER');
												// transform the XML to some HTML content
												newTopBannerData = xslProcessor_topbanner.transform(xmlTopBannerData, {'param':'value'});

												$('topbannerinfosection').innerHTML = newTopBannerData;
											}

										});
		//}
		//setTimeout('startBannerUpdate()', 200);
<? endif ?>

//		function startDateUpdate()
//		{
			var xslUrl_systemdate = '/systemdateXSL.php';
			var xslProcessor_systemdate = new XSLT(xslUrl_systemdate);

			new Ajax.PeriodicalUpdater('hostDate_hidden', '/cgi-bin/SystemDate',
										{
											method: 'POST',
											frequency: 300,
											onSuccess:function(transport)
											{

												// get the XML data
												try
												{
													var xmlSystemDateData = new XML(transport.responseXML);
												}
												catch (e)
												{
													alert(request.responseText);
												}

												// transform the XML to some HTML content
												newSystemDateData = xslProcessor_systemdate.transform(xmlSystemDateData, {'param':'value'});

												$('hostDate').innerHTML = newSystemDateData;
											}
										});
//		}
//		setTimeout('startDateUpdate()', 200);

<? endif ?>

		function startTimeUpdate()
		{
			new Ajax.PeriodicalUpdater('hostTime', '/cgi-bin/SystemTime',
										{
											method: 'POST',
											frequency: 30,
											decay: 1
										});
		}
		setTimeout('startTimeUpdate()', 10000);
</script>
<div id="container">
	<div id="topbanner">
<?php include('topbanner.php'); ?>
	</div>

	<div id="pleasewait"></div>

	<div class="gn_outside">
		<div class="gn" id="gn">
<?include('menu.php');?>
		</div>
	</div>

<? if($login->loggedin()) : ?>
	<div class="gn_sub_outside" id="gn_sub_outside" <? if($page == 'home'): ?>onmouseout="SetValues(event);"<? endif ?>>
<? $button->draw_submenus(); ?>
	</div>
<? endif ?>

<? if($message->count() > 0): ?>
	<div id="errormessage">
	<hr/>
<?= $message->dump() ?>
	<hr/>
	</div>
<? endif; ?>

	<div id="mainbody">
		<div id="maincontent">
<?include($page.'/content.php');?>
		</div>
	</div>

</div>
<?=$button->create_js_divs()?>
</body>
</html>
<?
/*
// check if browser supports gzip encoding
    if(strstr($_SERVER['HTTP_ACCEPT_ENCODING'],'gzip'))
    {
        $data=gzencode(ob_get_contents(),9);

        // clean up output buffer
        ob_end_clean();

        // send http header
        header('Content-Encoding: gzip');
    }
    else
    {
        $data=ob_get_contents();

        // clean up output buffer
        ob_end_clean();
    }

    // return data
    echo $data;
*/

my_exit();
?>
