<?php
class Locale {

var $version;
var $locale;
var $legend;
var $language_code;
var $encoding_code;
var $params = 
	Array
		(
			'version'    => array('/^[0-9]+\.[0-9]+\.[0-9]+$/',NULL,NULL,FALSE),
			'Language'   => array('/^[a-z]{2}_[A-Z]{2}\.utf8$/',NULL,NULL,FALSE),
		);

var $default = 'en_US.utf8';



function Locale($off=FALSE) {
	global $message;
	if($off) {
		return(TRUE);
	}
	if(!$this->readLocaleLegend()) {
		$message->add('Locale','Could not set locale');
		return(FALSE);
	}
	if(!$this->readLocaleFile()) {
		$message->add('Locale','Could not set locale');
		return(FALSE);
	}
	return(TRUE);
}



function validParam($p,$v) {
	if(!isset($this->params[$p])) {
		return(FALSE);
	}
	if((strlen($this->params[$p][0]) > 0) && (preg_match($this->params[$p][0],$v) != 1)) {
		return(FALSE);
	}
	if(($this->params[$p][3] !== FALSE) && ($v == $this->params[$p][3])) {
		return(TRUE);
	}
	if(($this->params[$p][1] !== NULL) && ($this->params[$p][2] !== NULL) && 
		($v < $this->params[$p][1] || $v > $this->params[$p][2])
	) {
		return(FALSE);
	}
	return(TRUE);
}



function readLocaleLegend() {

	global $ref;
	global $message;

	$fh = fopen($ref->smiCmLang_Legend,'r');
	if(!$fh) { 
		$message->add('Locale',sprintf('Could not open file %s',$ref->smiCmLang_Legend));
		return(FALSE); 
	}

	$a = array();
	$fail = FALSE;
	while(!feof($fh)) {
		$l = trim(fgets($fh));
		if(($pos = strpos($l,'//')) !== FALSE) {
			$l = substr($l,0,$pos);
		}
		if(strlen($l) <= 0) {
			continue;
		}		
		if(strpos($l,'=') === FALSE) { 
			$fail = 'no = on line '.$l; 
			break; 
		}
		$a = explode('=',$l);
		if(count($a) < 2) { continue; }
		if(strpos($a[0],'.utf8') === FALSE) { continue; }
		$this->legend[trim($a[0])] = trim($a[1]);
	}
	fclose($fh);
	if($fail !== FALSE) {
		$message->add('CmModem',"Could not parse file $file, $fail");
		return(FALSE);
	}
	return(TRUE);
}



function readLocaleFile($fn=NULL) {

	global $ref;
	global $message;

	$fn = $fn==NULL ? $ref->smiCmLang : $fn;
	$fh = fopen($fn,'r');
	if(!$fh) { 
		$message->add('Locale',sprintf('Could not open file %s',$fn));
		return(FALSE); 
	}

	$a = array();
	$fail = FALSE;
	while(!feof($fh)) {
		$l = trim(fgets($fh));
		if($l{0} == '#') { 
			continue;
		}
		if(strlen($l) < 1) {
			continue;
		}		
		if(strpos($l,'=') === FALSE) { 
			$fail = 'no = on line '.$l; 
			break; 
		}
		list($var,$val) = @explode('=',$l);
		$var = trim($var);
		$val = trim($val,"\" \t\n");
		if(!$this->validParam($var,$val)) { 
			$fail = 'no valid parameter on line '.$l; 
			break; 
		}
		if(strcmp($var,'version') == 0) {
			$this->version = $val;
		} elseif(strcmp($var,'Language') == 0) {
			$this->set($val);
		}
	}
	fclose($fh);
	if($fail !== FALSE) {
		$message->add('Locale',"Could not parse file $fn, $fail");
		return(FALSE);
	}
	return(TRUE);
}



function change($l) {
	global $ref;
	global $message;

	if(strcmp($l,$this->locale) === 0) { return(TRUE); }
	$this->set($l);
	$tmpfile = $ref->smiCmLang.".tmp";
	$cmd = "sed -e 's/^Language= .*/Language= ".$this->locale." /' ".$ref->smiCmLang." > $tmpfile";
	if(system($cmd,$ret) === FALSE) {
		$message->add('Locale',"Could not execute command $($cmd), $ret");
		return(FALSE);
	}
	$cmd = ("mv $tmpfile ".$ref->smiCmLang);
	if(system($cmd,$ret) === FALSE) {
		$message->add('Locale',"Could not execute command $($cmd), $ret");
		return(FALSE);
	}
	$this->readLocaleFile();
	if(strcmp($l,$this->locale) !== 0) {
		$message->add('Locale','Could not change file '.$ref->smiCmLang);
		return(FALSE);
	}
	return(TRUE);
}



function set($l) {
	$this->locale = isset($this->legend[$l]) ? $l : $this->default;
	$this->language_code = substr($this->locale, 0, strpos($this->locale, '.'));
	
	// a hack for now to accomodate the expected string of UTF-8 rather than utf8
	// for now this will work with all languages
	// locales is not installed any longer, so this is purely pulling from xml
	
	$encoding_code = substr($this->locale, 1+strpos($this->locale, '.'));
	$this->encoding_code = ($encoding_code == 'utf8') ? 'UTF-8' : $encoding_code;
}

}
?>
