<?php
class Menu {

var $buttonlist = array();	// list of buttons in the menu
var $buttontext = array();	// list text for the buttons in the menu
var $subbuttontext = array(); // list text for the sub menu buttons in menu
var $buttonstate = array(); // array of <a>-tag strings 
var $initialclickmessage = array(); // whether to display "please wait" message during loading
var $subpage = '';

function Menu($bl,$bt,$sp,$initial_click_message = null) {
	$this->buttonlist = $bl;
	
	if(is_array($initial_click_message))
		reset($initial_click_message);
		
	reset($bl);
	reset($bt);
	
	while(list($key,$val) = @each($bl)) 
	{
		$this->buttontext[$val] = current($bt);
		next($bt);
		
		if(is_array($initial_click_message))
		{
			$this->initialclickmessage[$val] = current($initial_click_message);
			next($initial_click_message);
		}		
	}
	$this->subpage = $sp;	// either make this '' or be sure to include a trailing '/'.
}


/*** Public Functions ***/
function create_js_divs()
{
	$js_array = null;
	$js_array .= '<script language="JavaScript" type="text/javascript">'."\n";
	$js_array .= 'var divs = new Array();'."\n";
	if(is_array($this->buttonlist))
	{
		foreach($this->buttonlist as $key => $i) {
			$js_array .= 'divs['.$key.'] = "'. $i .'";'."\n";
		}
	}
	$js_array .= '</script>'."\n";
	
	return $js_array;
}

function draw_submenus()
{
	foreach($this->buttonlist as $index => $name)
	{
		//echo "\n $index => $name";

		if(file_exists("$name/menu2.php"))
		{
			//echo "\n $name / menu2.php exists";
			include_once("$name/menu2.php");
			//echo "\n menu2.php included";
			
			echo '<div class="gn_sub" id="C_'. $name .'" style="display: none;">'."\n";
			
			//print_r($menu);
			foreach($menu['name'] as $key => $value)
			{
				if(isset($menu['destination'][$key]))
				{
					$destination = $menu['destination'][$key];
				}
				else
				{
					$destination = $name .'/'.$value;
				}
				
				if(isset($menu['target'][$key]))
				{
					$target = ' target="'.$menu['target'][$key].'" ';
					$onClick = '';
				}
				else
				{
					$target = '';
					$onClick = ' onClick="pleaseWait(1);" ';
				}
				
				$this->subbuttontext[$value] = $menu['label'][$key];
				
				echo '<ul><li><h2><a href="/'.$destination.'" '. $onClick . $target .'><nobr>'. $menu['label'][$key] .'</nobr></a></h2></li></ul>'."\n";
			}
			
			echo '</div>'."\n";
		}
	}
}

function breadcrumb($close_h2 = TRUE)
{
	global $page;
	global $subpage;
	
	return "<h2>".
				$this->buttontext[$page] . 
				(!empty($subpage) && $subpage != 'home' 
					?
						" &raquo; " .
						$this->subbuttontext[$subpage] 
					: 
						""
				) .
			($close_h2 
				? 
					"</h2>"
				:	""
			)
			;
}

function make_grey($s) {
	$this->buttonstate[$s] = '<a id="'. $s .'" hint="grey">'.$this->buttontext[$s].'</a>';
}
function make_normal($s) {

	$this->buttonstate[$s] = '<a hint="normal" id="'. $s .'"
					href="/'.
					$this->subpage.
					$s.
					(strpos($s,'.')===FALSE ? '/' : '" target="'.$s).
				 '" onmouseover="menu_show(this.id);">'.$this->buttontext[$s].'</a>';
}
function make_active($s) {
	//@$this->buttonstate[$s] = '<a class="active"><strong>'.$this->buttontext[$s].'</strong></a>';
	@$this->buttonstate[$s] = '<a hint="active" id="'.$s.'">'.$this->buttontext[$s].'</a>';
}
function all_normal() {

	foreach($this->buttonlist as $key => $i) {
		$this->make_normal($i);
	}	
}
function all_grey() {
	foreach($this->buttonlist as $i) {
		$this->make_grey($i);
	}
}
function state($s,$n=TRUE,$e='',$killHREF=FALSE) {
	$r = $this->buttonstate[$s];
	if( $killHREF ) 
	{
		$r = preg_replace('/href="[^"]*"/','',$r);
	}
	if( (strpos($r,'hint="active"') === FALSE) ) 
	{
		if( $e !== '' ) 
		{
			return(str_replace('<a ',"<a $e ",$r));
		}
		if( $n && (strpos($r,'hint="grey"') === FALSE)  ) 
		{
			if($this->initialclickmessage[$s] == true)
				$please_wait_param = true;
				
			return(str_replace('<a ','<a onClick="pleaseWait('. $please_wait_param .');" ',$r));
		}
	}

	return($r);
}
function select($s) {
	$this->all_grey();
	$this->make_active($s);
}

}
?>
