<?php

require_once('menu.class.php');

global $login;
global $page;
global $subpage;

$button = new Menu(
array(
'login',
'logout',
'network',
'site',
'accounts',
'devicecontrol',
'zonecontrol',
'zonereport.txt',
'filetransfer',
'logs',
'help',
'testcomms'),
array(
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to a login page.
*/
LOGIN,
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this logs the user out.
*/
LOGOUT,
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to a page where they change network
settings, including the Control Module II's IP address, subnet mask,
broadcast IP, and gateway.
*/
NETWORK_SETUP,
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to a page where they change 
information about the site where the Control Module II is deployed.
*/
sprintf(CONFIGURATION,CM_II),
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to a page where they can add and 
delete user accounts and change account passwords.
*/
USER_ACCOUNTS,
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to the Device Discovery page, an
important page for the process of setting up the security system.
"Devices" means our relay modules which monitor sensors that 
detect security breaches and which turn on alarms.
*/
DEVICE_MANAGEMENT,
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to the Zones page, an important
page for the process of setting up the security system.
Zones means "security zone", The user decides what area is to be
monitored, like a fence or a gate, then the user decides what kind
of alarm to sound for each zone, like a light, small bell, or siren.
*/
ZONE_ADMINISTRATION,
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to the a version of the Zones page
which reports which zones are valid and not valid.*/
ZONE_REPORT,
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to the File Transfer page,
which lets the user backup files and upload configuration files.
*/
_('Backup/Upgrade/Restore'),
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to the Reports page, which lets 
the user view and download alarm logs as well as a full configuration 
report.
*/
REPORTS,
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this loads a PDF file, which is a full technical
manual for operating the Control Module II.
*/
HELP,
TEST_COMMS
),
'',
// define whether to show a "Please Wait" message when loading the page
array(
'false',
'false',
'false',
'false',
'false',
'true',
'true',
'false',
'false',
'false',
'false',
'false')
);


$sr = trim($_SERVER["REQUEST_URI"],"/ ");
if(strcmp($page,'home') == 0) {
  $button->all_normal();
} else {
  $button->select($sr);
}

if(!$login->loggedin()) {
  $button->all_grey();
  if(strcmp($page,'login') == 0) {
    $button->make_active('login');
  } else {
    $button->make_normal('login');
  }
}

$button->make_normal('logout');
$button->make_normal('help');

/*
if(strcmp($page,'shutdown') == 0) {
	$button->make_active('shutdown');
} else {
	$button->make_normal('shutdown');
}
*/

?>
<?if($login->loggedin()):?>
<ul><li><h2><?=$button->state('site')?></h2></li></ul>
<ul><li><h2><?=$button->state('devicecontrol')?></h2></li></ul>
<ul><li><h2><?=$button->state('zonecontrol')?></h2></li></ul>
<!--
<ul><li><h2><?=$button->state('zonereport.txt',FALSE)?></h2></li></ul>
-->
<ul><li><h2><?=$button->state('logs')?></h2></li></ul>
<ul><li><h2><?=$button->state('testcomms')?></h2></li></ul>

<!--
<ul><li><h2><?=$button->state('accounts')?></h2></li></ul>
<ul><li><h2><?=$button->state('network')?></h2></li></ul>
<ul><li><h2><?=$button->state('filetransfer')?></h2></li></ul>
-->
<!--<li><?=$button->state('logout')?></li>-->
<!--<li><a href="help.pdf"><?= _('Help') ?></a></li>-->
<?else:?>
<ul><li><h2><?=$button->state('login')?></h2></li></ul>
<?endif;?>