<pre>
<?php

/*

------ Shared Memory Segments --------
key        shmid      owner      perms      bytes      nattch     status
0x11030a09 32768      root      666        5084       1
0x12030a09 65537      root      666        112        2
0x13030a09 98306      root      666        112        2
0x14030a09 131075     root      666        1044       2
0x15030a09 163844     root      666        264        2
0x16030a09 196613     root      666        272        2
0x17030a09 229382     root      666        36         2
0x19030a09 262151     root      666        36         2
0x18030a09 294920     root      666        72         2

------ Semaphore Arrays --------
key        semid      owner      perms      nsems
0x51030983 32768      root      666        1
0x52030983 65537      root      666        1
0x53030983 98306      root      666        1
0x54030983 131075     root      666        1
0x55030983 163844     root      666        1
0x56030983 196613     root      666        1
0x57030983 229382     root      666        1
0x59030983 262151     root      666        1
0x58030983 294920     root      666        1
0x00000000 327689     www-data  600        1
0x00000000 360458     www-data  600        1

------ Message Queues --------
key        msqid      owner      perms      used-bytes   messages
0x900309e3 32768      root       666        0            0
0x910309e3 65537      root       666        0            0
0x920309e3 98306      root       666        0            0
0x930309e3 131075     root       666        0            0
0x940309e3 163844     root       666        0            0
0x950309e3 196613     root       666        0            0
0x960309e3 229382     root       666        0            0
0x970309e3 262151     root       666        0            0

*/

$id = ftok ('/smi/ipc/shmid.txt' , chr(17));

$shm_id = shmop_open($id, "a", 0, 0);

if(!$shm_id)
{
    echo "Couldn't create shared memory segment\n";
}

// Get the size of shared memory block
$shm_size = shmop_size($shm_id);
//echo "SHM Block Size: ". $shm_size . " has been opened.\n";

// Read back the string
$data = shmop_read($shm_id, 0, $shm_size);

if(!$data)
{
    echo "Couldn't read from shared memory block\n";
}

$fp = fopen('/tmp/test.hex', 'w');
fwrite($fp, $data);
fclose($fp);

shmop_close($shm_id);

$memory_seg = new CM_DAEMON_SHARED($data);

$memory_seg->hexdump();
print_r($memory_seg);


define('CM_DAEMON_MAX_ZONES', 256);
define('CM_DAEMON_MAX_DEVICES', 256);


class CM_DAEMON_SHARED
{	
	var $raw_data;

	var $flag;						// smi_int16_t   flag;   // init, idle, busy, rsp, done
    var $requestCmd;				// smi_int16_t   requestCmd; // sys, log, cfg, discovery, zone
	
    var $cmDaemonVersion; 			// smi_int32_t   cmDaemonVersion; // 0x00010000 = 1.0.0

    var $newDateTime;				// smi_int8_t     newDateTime[16];
    var $currDateTime;				// smi_int8_t     currDateTime[16];
    var $mylocaltime;				// struct timeval mylocaltime;
    var $myPtm;						// struct tm      *myPtm;

	var $currFaultToleranceMode;	// smi_uint16_t  currFaultToleranceMode;

    var $totalZonesCreated;			// smi_int16_t   totalZonesCreated;
    var $totalZonesInAlarm;			// smi_int16_t   totalZonesInAlarm;
    var $totalZonesSecured;			// smi_int16_t   totalZonesSecured;
    var $totalZonesUnassigned;		// smi_int16_t   totalZonesUnassigned;
    var $totalZonesDisabled;		// smi_int16_t   totalZonesDisabled;
    var $zoneInfo;					// CM_DAEMON_ZONE_INFO   zoneInfo[CM_DAEMON_MAX_ZONES];

    var $currPort1_start_addr;		// smi_int16_t   currPort1_start_addr;
    var $currPort1_end_addr;		// smi_int16_t   currPort1_end_addr;
    var $currPort2_start_addr;		// smi_int16_t   currPort2_start_addr;
    var $currPort2_end_addr;		// smi_int16_t   currPort2_end_addr;

    var $totalDevices;				// smi_int16_t   totalDevices;
    var $totalDevicesComFailed;		// smi_int16_t   totalDevicesComFailed;
    var $totalDevicesCompromized;	// smi_int16_t   totalDevicesCompromized;
    var $totalDevicesServiced;		// smi_int16_t   totalDevicesServiced;

    var $magicKey1; 				// smi_int16_t   magicKey1;
    var $discDevices;				// CM_DAEMON_DISC_DEVICE  discDevices[CM_DAEMON_MAX_DEVICES];

    var $magicKey2;					// smi_int16_t   magicKey2;
    var $uiRequest;					// smi_int8_t    uiRequest[CM_DAEMON_SHARED_BFR_LEN];

    var $magicKey3;					// smi_int16_t   magicKey3;
    var $uiResponse;				// smi_int8_t    uiResponse[CM_DAEMON_SHARED_BFR_LEN];
 
    var $magicKey4;					// smi_int16_t   magicKey4;

	var $positions;
	
	var $deviceArray = array();
	var $devicePositions;						

	var $zoneArray = array();
	var $zonePositions;						


	function CM_DAEMON_SHARED($data)
	{
		$this->raw_data = $data;
		$this->createPositions();
		$this->process();	
		
		//to cleanup print_r
		//unset($this->raw_data);
	}
	
	function createPositions()
	{
 		$this->positions = array(
    						'flag' 						=> 2,
    						'requestCmd' 				=> 2,
    							
    						'cmDaemonVersion' 			=> 4,
    						
    						'newDateTime'				=> 8,
    						'currDateTime'				=> 8,
    						'mylocaltime'				=> 8,
    						'myPtm'						=> 20,
    						
    						'currFaultToleranceMode'	=> 2,
    						
    						'totalZonesCreated'			=> 2,
    						'totalZonesInAlarm' 		=> 2,
    						'totalZonesSecured' 		=> 2,
    						'totalZonesUnassigned' 		=> 2,
    						'totalZonesDisabled'		=> 2,
    						'zoneInfo'					=> 1024,
    						
    						'currPort1_start_addr'		=> 2,
    						'currPort1_end_addr'		=> 2,
    						'currPort2_start_addr'		=> 2,
    						'currPort2_end_addr'		=> 2,

							'totalDevices'				=> 2,
							'totalDevicesComFailed'		=> 2,
							'totalDevicesCompromised'	=> 2,
							'totalDevicesServiced'		=> 2,
							
							'magicKey1'					=> 2,
							'discDevices'				=> 2946,
							
							'magicKey2'					=> 2,
							'uiRequest'					=> 512,
							
							'magicKey3'					=> 2,
							'uiResponse'				=> 512,
							
							'magicKey4'					=> 2
							);		
		
			$this->createDevicePositions();
			$this->createZonePositions();
	}
	
	function createDevicePositions()
	{
		$this->devicePositions = array(
							'pad'						=> 2, // for some odd reason the compiler has decided to throw in a 2 byte pad at the start of the struct
							'deviceId'					=> 2,
							'status'	 				=> 2,
							'ttyPort'	 				=> 2,
							'pmasterId'	 				=> 2,
							'nodeAddr'	 				=> 2,
							'ftype'		 				=> 2,
							'commFailState'				=> 2,
							
							'prevCfgCsum' 				=> 2,
							'currCfgCsum' 				=> 2,
							'newCfgCsum' 				=> 2,
							
							'prevRelayOut' 				=> 2,
							'currRelayOut' 				=> 2,
							'newRelayOut' 				=> 2,
							
							'prevService' 				=> 2,
							'currService' 				=> 2,
							
							'macAddr'	 				=> 16,
							'name'						=> 72,
							'alarmBfr'					=> 64							
					);
	}

	function createZonePositions()
	{
		$this->zonePositions = array(
							'inuseFlag'					=> 1,
							'state'		 				=> 1,
							'pad'						=> 2 // for some odd reason the compiler has decided to throw in a 2 byte pad at the start of the struct							
					);
	}

	function hexstr($hexstr) 
	{
	  $hexstr = str_replace(' ', '', $hexstr);
	  $retstr = pack('H*', $hexstr);
	  return $retstr;
	}

	function process()
	{
		$data = $this->raw_data;
		// Init
		$hexi   = '';
		$ascii  = '';
		$offset = 0;
		$len    = strlen($data);

		// Upper or lower case hexidecimal
		$x = ($uppercase === false) ? 'x' : 'X';

		foreach($this->positions as $var => $size)
		{
			if($var == 'discDevices')
			{
				$discDevices_start = $offset;
			}
			else if($var == 'zoneInfo')
			{
				$discZones_start = $offset;
			}
			
			for ($i = $j = 0; $i < $size; $i++)
			{
				// Convert to hexidecimal
				$hexi .= sprintf("%02$x ", ord($data[$offset]));
				
				$offset += 1;
			}
			
			$this->$var = $hexi;

			if($var == 'discDevices')
			{
				$this->processDevices(substr($data,$discDevices_start, (($offset-1)-discDevices_start)));
			}
			else if($var == 'zoneInfo')
			{
				$this->processZones(substr($data,$discZones_start, (($offset-1)-discZones_start)));
			}

			$hexi   = $ascii = '';
		}
	}

	function processDevices($raw_data)
	{
		$data = $raw_data;
		// Init
		$hexi   = '';
		$ascii  = '';
		$offset = 0;
		$len    = strlen($data);

		// Upper or lower case hexidecimal
		$x = ($uppercase === false) ? 'x' : 'X';
		for($index = 0; $index < 16; $index++)
		{
			//echo "\nDevice $index";
			foreach($this->devicePositions as $var => $size)
			{
			//	echo "\n\tPosition $var => $size";
				for ($i = $j = 0; $i < $size; $i++)
				{
					// Convert to hexidecimal
					$hexi .= sprintf("%02$x ", ord($data[$offset]));

					$offset += 1;
				}
				
				if($var == 'name')
				{
					$this->deviceArray[$index][$var] = trim($this->hexstr($hexi));
				}
				else if($var == 'pad')	// for some odd reason the compiler has decided to throw in a 2 byte pad at the start of the struct
				{}
				else
				{
					$this->deviceArray[$index][$var] = $hexi;
				}

				$hexi   = $ascii = '';
			}
		}
	}

	function processZones($raw_data)
	{
		$data = $raw_data;
		// Init
		$hexi   = '';
		$ascii  = '';
		$offset = 0;
		$len    = strlen($data);

		// Upper or lower case hexidecimal
		$x = ($uppercase === false) ? 'x' : 'X';
		for($index = 0; $index < 256; $index++)
		{
			//echo "\nDevice $index";
			foreach($this->zonePositions as $var => $size)
			{
			//	echo "\n\tPosition $var => $size";
				for ($i = $j = 0; $i < $size; $i++)
				{
					// Convert to hexidecimal
					$hexi .= sprintf("%02$x ", ord($data[$offset]));

					$offset += 1;
				}
				
				if($var == 'name')
				{
					$this->zoneArray[$index][$var] = trim($this->hexstr($hexi));
				}
				else if($var == 'pad')	// for some odd reason the compiler has decided to throw in a 2 byte pad at the start of the struct
				{}
				else
				{
					$this->zoneArray[$index][$var] = $hexi;
				}

				$hexi   = $ascii = '';
			}
		}
	}

	function hexdump ($htmloutput = true, $uppercase = false, $return = false)
	{
		$data = $this->raw_data;
		// Init
		$hexi   = '';
		$ascii  = '';
		$dump   = ($htmloutput === true) ? '<pre>' : '';
		$offset = 0;
		$len    = strlen($data);

		// Upper or lower case hexidecimal
		$x = ($uppercase === false) ? 'x' : 'X';

		// Iterate string
		for ($i = $j = 0; $i < $len; $i++)
		{
			// Convert to hexidecimal
			$hexi .= sprintf("%02$x ", ord($data[$i]));

			// Replace non-viewable bytes with '.'
			if (ord($data[$i]) >= 32) {
				$ascii .= ($htmloutput === true) ?
								htmlentities($data[$i]) :
								$data[$i];
			} else {
				$ascii .= '.';
			}

			// Add extra column spacing
			if ($j === 7) {
				$hexi  .= '  ';
				$ascii .= '  ';
			}

			// Add row
			if (++$j === 16 || $i === $len - 1) {
				// Join the hexi / ascii output
				$dump .= sprintf("%04$x  %-49s  %s", $offset, $hexi, $ascii);

				// Reset vars
				$hexi   = $ascii = '';
				$offset += 16;
				$j      = 0;

				// Add newline            
				if ($i !== $len - 1) {
					$dump .= "\n";
				}
			}
		}

		// Finish dump
		$dump .= $htmloutput === true ?
					'</pre>' :
					'';
		$dump .= "\n";

		// Output method
		if ($return === false) {
			echo $dump;
		} else {
			return $dump;
		}
	}
}