<?php
class Zones {

//  TODO:
//  time grep 'zoneInuse= [^0].*' *.data | awk -F ':' '{print $1}'
//  smiCmZone_1.data
//  smiCmZone_2.data
//  
//  real    0m6.120s
//  user    0m5.110s
//  sys     0m0.500s


// config variables
// These variables are also configured 
// in the zone page in javascript

var $maxInputs = 8;     // MAXIMUM NUMBER FOR ZONE RECORDS
var $maxOutputs = 8; 	// MAXIMUM NUMBER FOR ZONE RECORDS

var $maxSubcells = 134; // OLD VARIABLE - TO BE DISCARDED WHEN DEEMED OK
var $maxSubcells_MTP_II = 134;
var $maxSubcells_PM_II = 216;

var $maxInputRelays = 16;  // OLD VARIABLE - TO BE DISCARDED WHEN DEEMED OK
var $maxInputRelays_AIM_II_8 = 8;
var $maxInputRelays_PM_II = 4;

var $maxOutputRelays_ROM_II_8 = 8;
var $maxOutputRelays_ROM_II_16 = 16;
var $maxOutputRelays = 16; // OLD VARIABLE - TO BE DISCARDED WHEN DEEMED OK

// internal variables
var $zoneFile;
var $nextBlankRecord;
var $errors;
var $discZoneStates = array();

var $params = 
	Array
		(
			'version'     => array('/^[0-9]+\.[0-9]+\.[0-9]+$/',NULL,NULL,FALSE),
			'zoneInuse'   => array('/^(0|1|-1)$/',0,1,-1),
			'zoneId'      => array('/^-?[0-9]+$/',0,256,-1),
			'zoneState'   => array('/^-?[0-9]+$/',0,14,-1),  
			'zoneName'    => array('/^.{0,80}$/',NULL,NULL,''),
			'zoneComment' => array('/^.{0,80}$/',NULL,NULL,''),
			'input'       => array(
'/^(NA|PM_II|ROM_II_16|ROM_II_8|AIM_II_8|MTP_II|MDL_330), -?[0-9]+, (CP|NA|CF|TA|SC|SF|IA|IF|SV|TR|MM|MP|MA), (0|1|-1), -?[0-9]+, -?[0-9]+, -?[0-9]+$/',
			NULL,NULL,FALSE),
			'relay_out' => array(
'/^(NA|ROM_II_16|ROM_II_8), -?[0-9]+, -?[0-9]+$/',
			NULL,NULL,FALSE)
		);



function Zone() {
	/* TRANSLATOR: Label.  Meaning, this zone is in the secure state. */
	ASSIGNED;
	/* TRANSLATOR: Label.  Meaning, this zone is in the accessible state. */
	ACCESSIBLE;
	/* TRANSLATOR: Label.  Meaning, this zone is in the accessible state. */
	ACCESS;
	/* TRANSLATOR: Label.  Meaning, this zone is unassigned to any device. */
	UNASSIGNED;

	return;
}



function clear() {
	unset($this->zoneFile);
	unset($this->nextBlankRecord);
}



function error($n,$t,$i,$s) {
	$this->errors[] = ZONE. " $n, $t ". NUMBER ." $i: $s";
}



function haveErrors() {
	return(count($this->errors) > 0 ? TRUE : FALSE);
}



function errors() {
	return($this->errors);
}



function listZones() {

	global $ref;

	$a = array();
	for($i=1; $i<=$ref->smiCmZoneMax; $i++) {
		$a[] = $ref->zoneFileName($i);
	}
	return $a;
}


function cmp($a,$b) {
	return(strcmp($a->zoneName,$b->zoneName));
}

/* DEBUG ONLY FUNCTION */
function microtime_float()
{
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}
/* DEBUG ONLY FUNCTION */

function readinZones($path=NULL,$validzones=FALSE,$inuseOnly=FALSE) {

	global $ref;
	global $message;

	//$time_start = $this->microtime_float();

	for( $i=1; $i<=$ref->smiCmZoneMax; $i++ ) 
	{
		if($inuseOnly && !$this->getCurrentStatus($i, true))
		{
			continue;
		}
		
		if( $this->readZoneFile($i,$path,$validzones) === FALSE ) {
			$message->add(ZONES,ERROR_COULD_NOT_OPEN_ZONE_FILE." $i");
			return(FALSE);
		}
	}

	//$time_end = $this->microtime_float();
	//$time = $time_end - $time_start;

	//echo "TOOK: $time seconds\n";


	if(is_array($this->zoneFile))
	{
		uasort($this->zoneFile,array(ZONES,"cmp"));
	}	
	
	return(TRUE);
}



function readZoneFile($n,$path=NULL,$validzones=FALSE,$fromTmp=FALSE) {
	$this->readZoneFileBase($n,FALSE,$path,$validzones,$fromTmp);
}



function readZoneFileForce($n,$path=NULL,$validzones=FALSE,$fromTmp=FALSE) {
	$this->readZoneFileBase($n,TRUE,$path,$fromTmp);
}



function readZoneFileBase($zr,$force,$path=NULL,$validzones=FALSE,$fromTmp=FALSE) {
	global $ref;
	global $message;
/*
	$mtime = microtime(); 
	$mtime = explode(" ",$mtime); 
	$mtime = $mtime[1] + $mtime[0]; 
	$starttime = $mtime; 
*/

	$def = $zr<=-1 ? TRUE : FALSE;
	$fn = $ref->zoneFileName($zr,$path);
	$zr = $zr<-1 ? -$zr : $zr;
	$fh = fopen($fn,'r');
	if( !$fh ) {
		$message->add(ZONE,ERROR_COULD_NOT_OPEN_FILE2. " $fn");
		return(FALSE);
	}

	$fail = FALSE;
	$blank = FALSE;
	$notInUse = FALSE;
	
	while( !feof($fh) ) {
		$l = trim(fgets($fh));
		if($l{0} == '#') {
			continue;
		}
		if(strlen($l) <= 0) {
			continue;
		}
		if(!isset($version) && strpos($l,'version') === 0) {
			$version = trim(substr($l,1+strpos($l,'=')));
			continue;
		} elseif(strpos($l,'=') === FALSE) { 
			$fail = 'no ='; 
			break;
		}
		list($var,$val) = @explode('=',$l);
		$var = trim($var);
		$val = trim($val,"\" \t\n");
		$n = FALSE;		
		if(strpos($var,'input') === 0) {
			$n = substr($var,6,1);
			$var = 'input';
			$inputtick = TRUE;
		}
		elseif(strpos($var,'relay_out') === 0) {
			$n = substr($var,10,1);
			$var = 'relay_out';
			$relayouttick = TRUE;
		}
		if(!$this->validParam($var,$val)) { 
			$fail = ERROR_NOT_VALID_PARAMETER; 
			break; 
		}
		if(strcmp($var,'zoneId') === 0) {
			if($val != $zr-1) { 
				$fail = $def ? FALSE : ERROR_BAD_ZONE_ID; 
				break; 
			}
			continue;
		}
		if(strpos($var,'zoneInuse') === 0) {
			if($val == 0)
			{
				$notInUse = true;
				break;
			}
		}		
		if($n !== FALSE) {
			$a = explode(', ',$val);
			foreach($a as $k=>$v) {
				$a[$k] = trim($v);
			}
			$this->zoneFile[$zr]->$var->$n = $a;
		} else { 
			$this->zoneFile[$zr]->$var = $val;
		}
	}
	fclose($fh);
	if($fail !== FALSE) {
		unset($this->zoneFile[$zr]);
		$message->add(ZONES, ERROR_ZONE_PARSE.", $fail - $fn");
		return(FALSE);
	}
	if($notInUse !== FALSE) {
		unset($this->zoneFile[$zr]);
		return(true);
	}	
	$inputcount = 0;
	$relayoutcount = 0;
	if(!$def) {
		foreach($this->zoneFile[$zr]->input as $n=>$ir) {
			$a =& $this->zoneFile[$zr]->input->$n;
			//echo '<pre>';
			//print_r($a);
			//echo '</pre>';

			$a['deviceType'] =& $a[0];
			$a['nodeAddr'] =& $a[1];
			$a['inputType'] =& $a[2];
			$a['parm1'] =& $a[3];
			$a['parm2'] =& $a[4];
			$a['parm3'] =& $a[5];
			$a['parm4'] =& $a[6];
			$a['parm1'] = $a['parm1']<=-1 ? -1 : ($ref->addForInputType[$a['inputType']] ? $a['parm1']+1 : $a['parm1']);
			$a['parm2'] = $a['parm2']<=-1 ? -1 : ($ref->addForInputType[$a['inputType']] ? $a['parm2']+1 : $a['parm2']);
			$a['parm3'] = $a['parm3']<=-1 ? -1 : ($ref->addForInputType[$a['inputType']] ? $a['parm3']+1 : $a['parm3']);
			$a['parm4'] = $a['parm4']<=-1 ? -1 : ($ref->addForInputType[$a['inputType']] ? $a['parm4']+1 : $a['parm4']);
			if($this->inputIsset($zr,$n)) { $inputcount++; }

			//echo '<pre>';
			//echo $a['deviceType'] . " @ ". $a['nodeAddr'] .": ". $a['inputType'] ." -- ADDING SET TO: " .intval($ref->addForInputType[$a['inputType']]) ."\n";
			//echo '</pre>';
			
		}
		foreach($this->zoneFile[$zr]->relay_out as $n=>$or) {
			$a =& $this->zoneFile[$zr]->relay_out->$n;
			$a['deviceType'] =& $a[0];
			$a['nodeAddr'] =& $a[1];
			$a['relayOutputMask'] =& $a[2];
			$a['relayOutputMask'] = $a['relayOutputMask']<=-1 ? -1 : $a['relayOutputMask']+1;
			if($this->outputIsset($zr,$n)) { $relayoutcount++; }
		}
	}
	$this->zoneFile[$zr]->isset = TRUE;
	if($inputcount == 0 && $relayoutcount == 0 && !$this->zoneFile[$zr]->zoneInuse) {
		if( !isset($this->nextBlankRecord) ) {
			$this->nextBlankRecord = $zr;
		}
		$this->zoneFile[$zr]->isset = FALSE;
		if( !$force ) {
			unset($this->zoneFile[$zr]);
		}
	}
	if($validzones) {
		if($inputcount == 0 || $relayoutcount == 0) {
			unset($this->zoneFile[$zr]);
		}
	} 


/*
   $mtime = microtime(); 
   $mtime = explode(" ",$mtime); 
   $mtime = $mtime[1] + $mtime[0]; 
   $endtime = $mtime; 
   $totaltime = ($endtime - $starttime); 
   echo "\n\n<br /><br />This file ($fn) was parsed in ".$totaltime." seconds\n\n"; 
*/   

	return(TRUE);
}



function validParam($p,$v) {
	global $message;

	$i = 0;
	if(!isset($this->params[$p])) {
		$message->add(ZONE_PARAM,FAILURE . " 1 : $p => $v");
		return(FALSE);
	}
	if((strlen($this->params[$p][0]) > 0) && (preg_match($this->params[$p][0],$v) != 1)) {
		$message->add(ZONE_PARAM,FAILURE. " 2 : $p => $v");
		return(FALSE);
	}
	if(($this->params[$p][3] !== FALSE) && ($v == $this->params[$p][3])) {
		return(TRUE);
	}
	if(($this->params[$p][3] !== FALSE) && (strcmp($v,$this->params[$p][3]) == 0)) {
		return(TRUE);
	}
	if(($this->params[$p][1] !== NULL) && ($this->params[$p][2] !== NULL) && 
		($v < $this->params[$p][1] || $v > $this->params[$p][2])
	) {
		$message->add(ZONE_PARAM, FAILURE." 3 : $p => $v");
		return(FALSE);
	}
	return(TRUE);
}



function writeZoneFile($zr,$path=NULL,$tc=FALSE,$rd=FALSE) {
	global $ref;
	global $message;

	$fnw = $tc ? $ref->zoneFileNameTmpCreate($path) : $ref->zoneFileName($zr,$path).'.tmp'; 
	if($tc && $rd) {
		$fnr = $ref->zoneFileNameDef($zr,$path);
		system("cp $fnr $fnw");
		return(TRUE);
	}

	$fnr = $ref->zoneFileName($zr,$path);
	$fhr = fopen($fnr,'r');
	if( !$fhr ) {
		$message->add(ZONE,ERROR_COULD_NOT_OPEN_FILE2. " $fnr");
		return(FALSE);
	}
	$fhw = fopen($fnw,'w');
	if( !$fhw ) {
		$message->add(ZONE,ERROR_COULD_NOT_OPEN_FILE2." $fnw");
		fclose($fhr);
		return(FALSE);
	}
	while( !feof($fhr) ) {
		$l = trim(fgets($fhr));
		if($l{0} == '#') {
			fwrite($fhw, "$l\n");
			continue;
		} elseif(strlen($l) <= 0) {
			continue;
		} elseif(!isset($version) && strpos($l,'version') === 0) {
			fwrite($fhw, "$l \n");
			continue;
		} else {
			fwrite($fhw, "zoneInuse= ".($this->zoneInuse($zr) !== FALSE ? $this->zoneInuse($zr) : -1)." \n");
			fwrite($fhw, "zoneId= ".($this->zoneId($zr) !== FALSE ? $this->zoneId($zr) : -1)." \n");
			fwrite($fhw, "zoneState= ".($this->zoneState($zr) !== FALSE ? $this->zoneState($zr) : -1)." \n");
			fwrite($fhw, "zoneName= ".$this->zoneName($zr)." \n");
			fwrite($fhw, "zoneComment= ".$this->zoneComment($zr)." \n");
			for($n=1; $n<=$this->maxInputs; $n++) {
				$a =& $this->zoneFile[$zr]->input->$n;
				fwrite($fhw, "input_$n= ".
					$a['deviceType'].', '.
					( strcmp($a['deviceType'],'NA')!=0 ? $a['nodeAddr'] : '-1' ).', '.
					( strcmp($a['deviceType'],'NA')!=0 ? $a['inputType'] : 'NA' ).', '.
					( strcmp($a['deviceType'],'NA')!=0 ? $a['parm1'] : '-1' ).', '.
					( strcmp($a['deviceType'],'NA')!=0 ? $a['parm2'] : '-1' ).', '.
					( strcmp($a['deviceType'],'NA')!=0 ? $a['parm3'] : '-1' ).', '.
					( strcmp($a['deviceType'],'NA')!=0 ? $a['parm4'] : '-1' )." \n");
			}
			for($n=1; $n<=$this->maxOutputs; $n++) {
				$a =& $this->zoneFile[$zr]->relay_out->$n;
				fwrite($fhw, "relay_out_$n= ".
					$a['deviceType'].', '.
					( strcmp($a['deviceType'],'NA')!=0 ? $a['nodeAddr'] : '-1' ).', '.
					( strcmp($a['deviceType'],'NA')!=0 ? $a['relayOutputMask'] : '-1' )." \n");
			}
			fwrite($fhw, "\n");
			fclose($fhw);
			fclose($fhr);
			if($tc === FALSE) {
				system("mv $fnw $fnr");
			}
			return(TRUE);
		}
	}
	fclose($fhw);
	fclose($fhr);
	return(FALSE);
}


function validateZoneFile($zr) {
	global $ref;
	global $message;
	$fail=FALSE;
	$s = $this->zoneComment($zr);
		
	if(strlen($s) > 80) {
		$message->add(ZONES,ERROR_COMMENT_TOO_LONG);
		$fail=TRUE;
	}
	if(strcmp($s,strtr(urlencode($s),'+',' '))!==0) {
		$message->add(ZONES,ERROR_COMMENT_INVALID_CHARACTERS);
		$fail=TRUE;
	}
	$s = $this->zoneName($zr);
	if(strlen($s) > 80) {
		$message->add(ZONES,ERROR_NAME_TOO_LONG);
		$fail=TRUE;
	}
	if(strcmp($s,strtr(urlencode($s),'+',' '))!==0) {
		$message->add(ZONES,ERROR_NAME_INVALID_CHARACTERS);
		$fail=TRUE;
	}
	$inputrecords = 0;
	foreach($this->zoneFile[$zr]->input as $n=>$a) {
		if(strcmp($this->inputDeviceType($zr,$n),'NA')===0) {
			continue;
		}
		$inputrecords++;
		$it = $this->inputType($zr,$n);

		$dev_type = $this->inputDeviceType($zr,$n);		
		$maxSubcells = "maxSubcells_" .$dev_type;
		$r1 = $this->inputStartSubcell($zr,$n);
		$r2 = $this->inputEndSubcell($zr,$n);
		
		$maxInputRelays = "maxInputRelays_".$dev_type;
		$r3 = $this->inputRelayNumber($zr,$n);

		if(strcmp($it,'NA')===0) {
			$message->add(ZONES,sprintf(ERROR_NEED_INPUT_TYPE,$n));
			$fail=TRUE;
		}
		if($ref->paramsForInputType[$it][0] && !in_array($this->inputCableId($zr,$n),$ref->cableIds) ) {
			$message->add(ZONES,sprintf(ERROR_NEED_CABLE_ID,$n));
			$fail=TRUE;
		}		
		if($ref->paramsForInputType[$it][1] && ($r1 < 0 || $r1 >= $this->$maxSubcells) ) {
			$message->add(ZONES,
				sprintf(ERROR_START_SUBCELL_OUT_OF_BOUNDS,($this->$maxSubcells-1),$n));
			$fail=TRUE;
		}	
		if($ref->paramsForInputType[$it][2] && ($r2 < 0 || $r2 >= $this->$maxSubcells) ) {
			$message->add(ZONES,
				sprintf(ERROR_END_SUBCELL_OUT_OF_BOUNDS,($this->$maxSubcells-1),$n));
			$fail=TRUE;
		}		
		if($ref->paramsForInputType[$it][3] && ($r3 < 1 || $r3 > $this->$maxInputRelays) ) {
			$message->add(ZONES,
				sprintf(ERROR_INPUT_RELAY_OUT_OF_BOUNDS,
					$this->$maxInputRelays,$n));
			$fail=TRUE;
		}
		
		if($ref->paramsForInputType[$it][1] && $ref->paramsForInputType[$it][2] && ($r1 > $r2 ) ) {
			$message->add(ZONES,
				sprintf(ERROR_SUBCELL_SWAP,$n));
			$fail=TRUE;
		}		
	}
	if($inputrecords <= 0) {
		// TEMPORARY "FIX" TO ALLOW PROCEEDING WITHOUT INPUT RECORDS
		//$message->add(ZONES,_('There are no input records.'));
		//$fail=TRUE;
		
		$message->add(ZONES,ERROR_NO_INPUTS);
		
		
	}
	$outputrecords = 0;
	foreach($this->zoneFile[$zr]->relay_out as $n=>$a) {
		if(strcmp($this->outputDeviceTypeString($zr,$n),'NA')===0) {
			continue;
		}
		$outputrecords++;
		$r1 = $this->outputRelayNumber($zr,$n);
		$dev_type = $this->outputDeviceTypeString($zr,$n);
		
		$maxOutputRelays = "maxOutputRelays_" .$dev_type;
		if($r1 < 1 || $r1 > $this->$maxOutputRelays) {
			$message->add(ZONES,sprintf(ERROR_OUTPUT_RELAY_OUT_OF_BOUNDS,
				$this->$maxOutputRelays,$n));
			$fail=TRUE;
		}
	}
	if($outputrecords <= 0) {
		// TEMPORARY "FIX" TO ALLOW PROCEEDING WITHOUT INPUT RECORDS
		//$message->add(ZONES,_('There are no output records.'));
		//$fail=TRUE;
		$message->add(ZONES,ERROR_NO_OUTPUTS);

	} 
	return(!$fail);
}

function commitZoneFile($zr) {
	global $ref;
	$tf = $ref->zoneFileNameTmpCreate();
	$f = $ref->zoneFileName($zr);
	system("sed -i 's/smiCmZone_[0-9]*.data/smiCmZone_$zr.data/' ".$tf);
	system("sed -i 's/zoneId=.*/zoneId= ".($zr-1)." /' ".$tf);
	system("mv $tf $f");
	return(TRUE);
}

function cleanTmpZoneFile($zr) {
	global $ref;
	$tf = $ref->zoneFileNameTmpCreate();
	if(file_exists($tf)) {
		system("rm $tf");
	}
	return(TRUE);
}

function cleanupZoneDevices($discoveryList)
{
	// add optimization which checks which zones are active 
	// only those that are not UNASSIGNED need to be sed'ed
	
	global $ref;
	global $message;
	
	$nodeIDListArray = array();
	$nodeIDList = '';
	
	foreach($discoveryList as $vals)
	{
		$nodeIDListArray[] = $vals['nAddr'];
	}
		
	$nodeIDList = implode('|',$nodeIDListArray);
	
	$cmd = "sed -i '/^input_[0-9]=\ [0-9A-Z_]*,\ -\{0,1\}[".$nodeIDList."],\ .*\|^[#|v|z|relay|\ ].*/!s/^\(input_[0-9]\).*/\\1=\ NA,\ -1,\ NA,\ -1,\ -1,\ -1,\ -1\ /g ' ".$ref->smiCmZonePath."/*.data";
	if(system( $cmd ) != 0) {
		$message->add(ZONE,ERROR_COULD_NOT_EXECUTE_COMMAND.$cmd);
		return(FALSE);
	}
	
	$cmd = "sed -i '/^relay_out_[0-9]=\ [0-9A-Z_]*,\ -\{0,1\}[".$nodeIDList."],\ .*\|^[#|v|z|input|\ ].*/!s/^\(relay_out_[0-9]\).*/\\1=\ NA,\ -1,\ -1\ /g ' ".$ref->smiCmZonePath."/*.data";
	if(system( $cmd ) != 0) {
		$message->add(ZONE,ERROR_COULD_NOT_EXECUTE_COMMAND.$cmd);
		return(FALSE);
	}
	
	return(TRUE);
}

function updateZoneStates() {
	global $ref;
	global $message;

	$fh = fopen($ref->smiNewZones,'r');
	if( !$fh ) {
		$message->add(ZONE,ERROR_COULD_NOT_OPEN_FILE2.$ref->smiNewZones);
		return(FALSE);
	}
	while( !feof($fh) ) {
		$l = trim(fgets($fh));
		if(strlen($l) <= 0) {
			continue;
		}
		list($zr,$st) = @explode(',',$l);
		if($st===FALSE || $zr===FALSE) {
			$message->add(ZONE,ERROR_FILE_NOT_READABLE2.$ref->smiNewZones);
			fclose($fh);
			return(FALSE);
		}
		$zr = trim($zr);
		$st = trim($st);
		
		//echo '<pre>';
		//echo "$zr : $st \n";
		//echo '</pre>';
		
		// if the zone state is UNASSIGNED (0x0)
		// we can not change the zone file, saving time
		if($st == 0)
			continue;
		
		$this->discZoneStates[$zr+1] = $st;
	}
	fclose($fh);

	foreach($this->discZoneStates as $zr=>$st) {
		$cmd = "sed -i 's/zoneState=.*/zoneState= $st /' ".$ref->zoneFileName($zr);
		if(system( $cmd ) != 0) {
			$message->add(ZONE,ERROR_COULD_NOT_EXECUTE_COMMAND.$cmd);
			return(FALSE);
		}
	}
	return(TRUE);
}



function zoneId($zr) {
	return($zr-1);
}

function zoneComment($zr) {
	return(isset($this->zoneFile[$zr]->zoneComment) ? $this->zoneFile[$zr]->zoneComment : FALSE);
}

function zoneName($zr) {
	return(isset($this->zoneFile[$zr]->zoneName) ? $this->zoneFile[$zr]->zoneName : FALSE);
}

function zoneState($zr,$force=FALSE) {
	if($zr < 0 && !$force) { 
		return FALSE; 
	}
	//return (isset($this->zoneFile[$zr]->zoneState) ? $this->zoneFile[$zr]->zoneState : FALSE);
	
	// get the actual zone state if possible rather than value from the zone files
	// the reading of the zone file is necessary because current method of setting assigned/unassigned 
	// state for new zones
	
	return ($this->getCurrentStatus($zr) ? 
				$this->getCurrentStatus($zr) : 
				(isset($this->zoneFile[$zr]->zoneState) ? 
						$this->zoneFile[$zr]->zoneState : 
						FALSE
				)
			);
}

function zoneStateString($zr) {
	global $ref;
	$zs = $this->zoneStateFullString($zr);
	if($zs===FALSE) {
		return(FALSE);
	}
	
	//$n = strpos($zs,'_');
	//return($n===FALSE ? $zs : substr($zs,0,$n));
	
	return str_replace('_', ' ', constant($zs));
}

function zoneStateFullString($zr) {
	global $ref;
	$zs = $this->zoneState($zr,TRUE);
	if($zs===FALSE) {
		return(FALSE);
	}
	return($ref->sharedMemoryToZoneState[$zs]);
}

function zoneStateOrDefault($zr, $allow_alarms = TRUE) {
	global $ref;
	$zs = $this->zoneState($zr);
	if($allow_alarms)
	{
		$zs = $zs & 3;
	}
	return($zs!==FALSE ? $zs : $ref->zoneStateDefault );
}

function zoneStateColor($zr) {
	$zs = $this->zoneStateString($zr);

	switch($zs) {
	case 'ASSIGNED':
		return('assigned');
	case 'ASSIGNED ALARM':
		return('assigned-alarm');		
	case 'ACCESSIBLE':
	case 'ACCESS':
		return('access');
	default:
		return('unassigned');
	}
}

function zoneInuse($zr) {
	return(isset($this->zoneFile[$zr]->zoneInuse) ? $this->zoneFile[$zr]->zoneInuse : FALSE);
}

function zoneIsset($zr) {
	return( isset($this->zoneFile[$zr]) && $this->zoneFile[$zr]->isset );
}

function inputIsset($zr,$n) {
	return( $this->inputNodeAddr($zr,$n) == -1 ? FALSE : TRUE );
}

function inputDeviceType($zr,$n) {
	$a =& $this->zoneFile[$zr]->input->$n;
	return( isset($a['deviceType']) ? $a['deviceType'] : -1 );
}

function inputDeviceTypeString($zr,$n) {
	global $ref;
	$i = $this->inputDeviceType($zr,$n);
	return( isset($ref->deviceString[$i]) ? $ref->deviceString[$i] : 'NA' );
}

function inputNodeAddr($zr,$n) {
	$a =& $this->zoneFile[$zr]->input->$n;
	return( isset($a['nodeAddr']) ? $a['nodeAddr'] : -1 );
}

function inputType($zr,$n) {
	$a =& $this->zoneFile[$zr]->input->$n;
	return( isset($a['inputType']) ? $a['inputType'] : -1 );
}

function inputTypeString($zr,$n) {
	global $ref;
	$i = $this->inputType($zr,$n);
	
	// bad hack to overcome PM different tag for same type of input for IF
	$return_val = 	(is_array($ref->inputTypeString[$i]) ? 
							(($ref->deviceStringToSharedMemory[$this->inputDeviceType($zr,$n)] == 1) ?
									$ref->inputTypeString[$i][1] :
									$ref->inputTypeString[$i][0]
							) : 
							$ref->inputTypeString[$i]
					);
	
	
	return( isset($return_val) ? $return_val : 'NA' );
}

function inputCableId($zr,$n) {
	$a =& $this->zoneFile[$zr]->input->$n;
	return( isset($a['parm1']) ? $a['parm1'] : -1 );
}

function inputCableIdString($zr,$n) {
	global $ref;
	$i = $this->inputCableId($zr,$n);
	return( isset($ref->cableIdString[$i])  ? $ref->cableIdString[$i] : 'NA' );
}

function inputCableIdHasvalue($zr,$n) {
	global $ref;
	if( !($ref->paramsForInputType[$this->inputType($zr,$n)][0]) ) {
		return(FALSE);
	}
	return( $this->inputCableId($zr,$n) == -1 ? FALSE : TRUE );
}

function inputStartSubcell($zr,$n) {
	$a =& $this->zoneFile[$zr]->input->$n;
	return( isset($a['parm2']) ? $a['parm2'] : -1 );
}

function inputStartSubcellDisplay($zr,$n) {
	$i = $this->inputStartSubcell($zr,$n);
	return( $i == -1 ? '' : $i );
}

function inputStartSubcellHasvalue($zr,$n) {
	global $ref;
	if( !($ref->paramsForInputType[$this->inputType($zr,$n)][1]) ) {
		return(FALSE);
	}
	return( $this->inputStartSubcell($zr,$n) == -1 ? FALSE : TRUE );
}

function inputEndSubcell($zr,$n) {
	$a =& $this->zoneFile[$zr]->input->$n;
	return( isset($a['parm3']) ? $a['parm3'] : -1 );
}

function inputEndSubcellDisplay($zr,$n) {
	$i = $this->inputEndSubcell($zr,$n);
	return( $i == -1 ? '' : $i );
}

function inputEndSubcellHasvalue($zr,$n) {
	global $ref;
	if( !($ref->paramsForInputType[$this->inputType($zr,$n)][2]) ) {
		return(FALSE);
	}
	return( $this->inputEndSubcell($zr,$n) == -1 ? FALSE : TRUE );
}

function inputRelayNumber($zr,$n) {
	$a =& $this->zoneFile[$zr]->input->$n;
	return( isset($a['parm4']) ? $a['parm4'] : -1 );
}

function inputRelayNumberDisplay($zr,$n) {
	$i = $this->inputRelayNumber($zr,$n);
	return( $i == -1 ? '' : $i );
}

function inputRelayNumberHasvalue($zr,$n) {
	global $ref;
	if( !($ref->paramsForInputType[$this->inputType($zr,$n)][3]) ) {
		return(FALSE);
	}
	return( $this->inputRelayNumber($zr,$n) == -1 ? FALSE : TRUE );
}

function outputIsset($zr,$n) {
	return( $this->outputNodeAddress($zr,$n) == -1 ? FALSE : TRUE );
}

function outputDeviceType($zr,$n) {
	$a =& $this->zoneFile[$zr]->relay_out->$n;
	return( !isset($a['deviceType']) ? -1 : $a['deviceType'] );
}

function outputDeviceTypeString($zr,$n) {
	global $ref;
	$i = $this->outputDeviceType($zr,$n);
	return( $i == -1 ? 'NA' : $i );
}

function outputNodeAddress($zr,$n) {
	$a =& $this->zoneFile[$zr]->relay_out->$n;
	return( isset($a['nodeAddr']) ? $a['nodeAddr'] : -1 );
}

function outputRelayNumber($zr,$n) {
	$a =& $this->zoneFile[$zr]->relay_out->$n;
	return( isset($a['relayOutputMask']) ? $a['relayOutputMask'] : -1 );
}

function outputRelayNumberDisplay($zr,$n) {
	$i = $this->outputRelayNumber($zr,$n);
	return( $i == -1 ? '' : $i );
}

function getCurrentStatus($zoneNumber = null, $returnInuse = false, $useCache = true)
{
	$returnZones = array();
	
	// we need to recreate the cache each time the page is loaded for zone status information 
	// zones can go into alarm more often than the session is cleared
	// the cache is for storing the zone status within the current page load
	// $_SESSION['page_load_time'] is set at the top of /index.php with the unix timestamp
	if(!$useCache || empty($_SESSION['zoneStatusCache']) || ($_SESSION['page_load_time'] != $_SESSION['zoneStatusCacheCreated']) )
	{
		unset($_SESSION['zoneStatusCache']);

		global $ref;
		exec ( $ref->CGIDIR . '/ZoneStatus', $_SESSION['zoneStatusCache']);
		$_SESSION['zoneStatusCacheCreated'] = $_SESSION['page_load_time'];
	}

	// speedpass to avoid foreach
	if(isset($zoneNumber))
	{
		if($returnInuse)
		{
			return $_SESSION['zoneStatusCache'][$zoneNumber]{0};
		}
		else
		{
			return trim($_SESSION['zoneStatusCache'][$zoneNumber]{2} . $_SESSION['zoneStatusCache'][$zoneNumber]{3});
		}
	}
	else
	{
		foreach($_SESSION['zoneStatusCache'] as $key => $zoneStatus)
		{
			if(empty($zoneStatus))
			{
				continue;
			}

			// this took too long
			// $thisZoneStatus = explode(' ', $zoneStatus);

			if($returnInuse)
			{
				$returnZones[$key] = $zoneStatus{0};
			}
			else
			{
				$returnZones[$key] = trim($zoneStatus{2} . $zoneStatus{3});
			}
		}
	}
	return $returnZones;	
}


}

?>
