<?php

require_once('zone.class.php');
require_once('device.class.php');

global $page;
global $subpage;
global $ref;
global $message;

srand(time());
$rand = rand(0,9999);

if(!isset($_POST['s'])) {
    $_POST['s'] = 0; 
}

foreach($_POST as $k=>$v) {
	$_POST[$k] = trim(
		urldecode(
			preg_replace('/%[0-9a-fA-F]{1,2}/','',
				urlencode($v)
	)));
	if((strcmp($k,'zoneName') === 0) || (strcmp($k,'zoneComment') === 0)) {
		$_POST[$k] = substr($_POST[$k],0,67);
	}
}

if(isset($_GET['validzones'])) {
	$validzones = TRUE;
    $_POST['s'] = 0; 
} else {
	$validzones = FALSE;
}

$zones = new Zones;
$devices = new Devices;

switch ($_POST['s']) {

case '2':
/* change zone record */

// FALLTHRU
case '1':
/* add new zone record */
$devices->readinDevices();
$zr = $_POST['s'] == 2 ? $_POST['zr'] : -$_POST['zr'];
$zones->readZoneFile($zr);

$zoneIsChanging = ($_POST['s'] == 2 ? TRUE : FALSE); 

break;
case '4':
/* Confirm Add Zone Record */
/* Confirm Change Zone Record */

// FALLTHRU
case '5':
/* Return Add/Change Zone Record from CGI */

$zr = $_POST['zr'];
$zones->readZoneFile($zr);

$zones->zoneFile[$zr]->zoneInuse = 1;
$zones->zoneFile[$zr]->zoneId = $zr-1;
if(isset($_POST['state'])) {
	$zones->zoneFile[$zr]->zoneState = $_POST['state'];
	$zones->zoneFile[$zr]->state = $_POST['state'];
} else {
	$zones->zoneFile[$zr]->zoneState = isset($_POST['zoneState']) ? $_POST['zoneState'] : $ref->zoneStateDefault;
	$_POST['state'] = $zones->zoneFile[$zr]->state = $zones->zoneFile[$zr]->zoneState;
}

$zones->zoneFile[$zr]->zoneName = isset($_POST['zoneName']) ? $_POST['zoneName'] : '';
$zones->zoneFile[$zr]->zoneName = substr($zones->zoneFile[$zr]->zoneName,0,67);
$zones->zoneFile[$zr]->zoneComment = isset($_POST['zoneComment']) ? $_POST['zoneComment'] : '';
$zones->zoneFile[$zr]->zoneComment = substr($zones->zoneFile[$zr]->zoneComment,0,67);

foreach($_POST as $k=>$v) {
	if(strpos($k,'in') === 0) {
		$a = explode('_',$k);
		$input =& $zones->zoneFile[$zr]->input->$a[1];
		if(strpos($a[2],'nodeAddrDeviceType') !== FALSE) {
			if(strpos($v,'.') === FALSE) {
				$input['nodeAddr'] = -1;
				$input['deviceType'] = 'NA';
			} else {
				$aa = explode('.',$v);
				$input['nodeAddr'] = $aa[0];
				$input['deviceType'] = $ref->sharedMemoryToDeviceString[$aa[1]];
			}
		} elseif (strpos($a[2],'inputType') !== FALSE) {
			$input[$a[2]] = $ref->sharedMemoryToInputType[trim($v)];
		} else {
			$input[$a[2]] = trim($v) == '' ? -1 : $v;
		}
	} elseif(strpos($k,'out') === 0) {
		$a = explode('_',$k);
		$relay_out =& $zones->zoneFile[$zr]->relay_out->$a[1];
		if(strpos($a[2],'nodeAddrDeviceType') !== FALSE) {
			if(strpos($v,'.') === FALSE) {
				$relay_out['nodeAddr'] = -1;
				$relay_out['deviceType'] = 'NA';
			} else {
				$aa = explode('.',$v);
				$relay_out['nodeAddr'] = $aa[0];
				$relay_out['deviceType'] = $ref->sharedMemoryToDeviceString[$aa[1]];
			}
		} else {
			$relay_out[$a[2]] = trim($v) == '' ? -1 : $v;
		}
	}
}

if($_POST['s'] == 4) {
	if($zones->validateZoneFile($zr) === FALSE) {
		$message->add(_('Zones'),_('Zone file not valid'));
		$_POST['s'] = 2;
	}
}

if($_POST['s'] == 5) {
	$zones->writeZoneFile($zr,NULL,FALSE,FALSE); // to permanent file
	$zones->cleanTmpZoneFile($zr);
	$zones->readinZones();
	$_POST['s'] = 0;
} else {
	$zones->writeZoneFile($zr,NULL,TRUE,FALSE); // to temporary file
}

break;

case '3':
/* Delete Zone Record */

$zr = $_POST['zr'];
$zones->readZoneFile($zr);
$zones->writeZoneFile($zr,NULL,TRUE,TRUE); // defaults to temporary file
break;

case '0':
/* Main Page of Zone Control */
default:
	$_POST['s'] = 0;


// Final step of the Create Zone and Delete Zone process
	if(isset($_POST['zr'])) {
		$zr = $_POST['zr'];
		if(isset($_POST['createsuccess']) || isset($_POST['deletesuccess'])) {
			$zones->commitZoneFile($zr);
		} else {
			$zones->cleanTmpZoneFile($zr);
		}
	}
	$zones->readinZones(NULL,$validzones);

} // endswitch

?>



<? if($message->count() > 0): ?>
		<div id="errormessage">
		<hr/>
<?= $message->dump() ?>
		<hr/>
		</div>
<? endif ?>

<form class="formquit" method="POST" 
<? if($_POST['s']===0): ?>
action="/" onSubmit="pleaseWait(); " 
<? else: ?>
action="/<?= $page ?>/" target="rootDocument" onSubmit="pleaseWait(); self.close(); " 
<? endif ?> 
 >
<input class="submitquit only" type="submit" name="submit" value="<?= _('Quit') ?>" />
</form>


<h2><?= _('CM-II') ?> <?= /* TRANSLATOR: Header Text */ _('Zone Control') ?> <? // CAREFUL: switch must close the /h2 ?>

<? switch($_POST['s']): ?>
<? case '3': ?>
 - <?= /* TRANSLATOR: Header Text */ _('Delete Zone Record') ?>
<? case '4': ?>
<? if ($_POST['s'] == 4 || $_POST['s'] == 5): ?>
 - <?= /* TRANSLATOR: Header Text */ _('Confirm Zone Record Entry') ?>
<? endif ?>
<? case '0': ?>
<?= $validzones ? ' - '. /* TRANSLATOR: Header Text */ _('Zone Report') : '' ?></h2>

<table class="zone" summary="Current Zone Records">
	<tr>
		<td colspan="3">
<? if($_POST['s'] == 0): ?>
<? if(!$validzones): ?>
			<form method="POST" action="" target="zone<?= $rand ?>" onSubmit="pleaseWait(); openwin('','zone<?= $rand ?>'); self.close(); ">
				<input type="hidden" name="s" value="1" />
				<input type="hidden" name="zr" value="<?= $zones->nextBlankRecord ?>" />
				<input style="padding:0;margin:0;float:right" class="submitbutton" type="submit" name="submit" value="<?=
				/* TRANSLATOR: Button Text */
				_('Add New Zone') 
				?>" />
			</form>
<? endif ?>
<? endif ?>
		</td>
	</tr>
<? if(count($zones->zoneFile) <= 0): ?>
	<tr>
		<td><?= _('No zones on record') ?></td>
	</tr>
<? endif ?>
<? foreach($zones->zoneFile as $zr => $zf): ?>
<? $zsc = $zones->zoneStateColor($zr) ?>
<? if( $zones->zoneInuse($zr) ): ?>
	<tr>
		<th class="<?= $zsc ?>" colspan="2">
			<?=
			/* TRANSLATOR: Table Header */
			_('Zone Record') 
			?> <?= $zr <= -1 ?
sprintf( ' ** %s ** ', /* TRANSLATOR: Meaning new zone record */ _('NEW') ) :
''
			?> - <strong><?= _($zones->zoneStateString($zr)) ?></strong>
		</th>
		<th class="<?= $zsc ?>" colspan="1">
<? if($_POST['s'] == 0): ?>
<? if(!$validzones): ?>
			<form method="POST" action="" target="zone<?= $rand ?>" onSubmit="pleaseWait(); openwin('','zone<?= $rand ?>'); self.close(); ">
				<input type="hidden" name="s" value="2" />
				<input type="hidden" name="zr" value="<?= $zr ?>" />
				<input style="padding:0;margin:0 0.25em;float:right" class="submitbutton" type="submit" name="Change" value="<?=
				/* TRANSLATOR: Button Text */
				_('Change') 
				?>" />
			</form>
<? endif ?>
<? if(!$validzones): ?>
			<form method="POST" action="" target="zone<?= $rand ?>" onSubmit="pleaseWait(); openwin('','zone<?= $rand ?>'); self.close(); ">
				<input type="hidden" name="s" value="3" />
				<input type="hidden" name="zr" value="<?= $zr ?>" />
				<input style="padding:0;margin:0 0.25em;float:right" class="submitbutton" type="submit" name="Delete" value="<?=
				/* TRANSLATOR: Button Text */
				_('Delete') 
				?>" />
			</form>
<? endif ?>
<? endif ?>
		</th>
	</tr>
	<tr>
		<td class="<?= $zsc ?>" colspan="3">
			<table>
				<tr>
					<th>
						<?=	/* TRANSLATOR: Meaning the name which a user gives a zone */ _('Name') ?>:
					</th>
					<td>
						<?= $zones->zoneName($zr) ?>
					</td>
				</tr>
				<tr>
					<th>
						<?=
/* TRANSLATOR: Meaning the comment which a user puts on a zone to remind the user what the zone is for */
_('Comment') ?>:
					</th>
					<td>
						<?= $zones->zoneComment($zr) ?>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<th colspan="2" class="<?= $zsc ?>">
			<?= /* TRANSLATOR: Table Header */ _('Assigned Inputs') ?>
		</th>
		<th colspan="1" class="<?= $zsc ?>">
			<?= /* TRANSLATOR: Table Header */ _('Assigned Outputs')?>
		</th>
	</tr>
	<tr>
		<td>
			<table>
				<tr>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning Device Address */ _('Adr') ?></th>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning which Device */ _('Device') ?></th>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning which input */ _('Input') ?></th>
					<th>&nbsp;</th>
				</tr>
<? foreach( $zf->input as $n=>$ir ): ?>
<? if(!$zones->inputIsset($zr,$n)): ?>
<? continue ?>
<? endif ?>
				<tr>
					<td><?= $zones->inputNodeAddr($zr,$n) ?></td>
					<td><?= $zones->inputDeviceType($zr,$n) ?></td>
					<td><?= $zones->inputTypeString($zr,$n) ?></td>
					<td>
						<table class="zoneparms">
<? if( $zones->inputCableIdHasvalue($zr,$n) ): ?>
							<tr>
								<td style="text-align:right">
									<?=
									/* TRANSLATOR: Table Header. Indicates which cable. */
									_('Cable ID') 
									?>:&nbsp;
								</td>
								<td><?= _($zones->inputCableIdString($zr,$n)) ?></td>
							</tr>
<? endif ?>
<? if( $zones->inputStartSubcellHasvalue($zr,$n) ): ?>
							<tr>
								<td style="text-align:right">
									<?=
									/* TRANSLATOR: Table Header. Indicates which subcell to start from. */ 
									_('Start Subcell') 
									?>:&nbsp;
								</td>
								<td><?= $zones->inputStartSubcell($zr,$n) ?></td>
							</tr>
<? endif ?>
<? if( $zones->inputEndSubcellHasvalue($zr,$n) ): ?>
							<tr>
								<td style="text-align:right">
									<?= 
									/* TRANSLATOR: Table Header. Indicates which subcell to end with. */ 
									_('End Subcell') 
									?>:&nbsp;
								</td>
								<td><?= $zones->inputEndSubcell($zr,$n) ?></td>
							</tr>
<? endif ?>
<? if( $zones->inputRelayNumberHasvalue($zr,$n) ): ?>
							<tr>
								<td style="text-align:right">
									<?= 
									/* TRANSLATOR: Table Header. Indicates which relay. */ 
									_('Input Relay') 
									?>:&nbsp;
								</td>
								<td><?= $zones->inputRelayNumber($zr,$n) ?></td>
							</tr>
<? endif ?>
						</table>
					</td>
				</tr>
<? endforeach; // End Inputs ?> 
			</table>
		</td>
		<td class="<?= $zsc ?>">&nbsp;</td>
		<td>
			<table>
				<tr>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning Device Address */ _('Adr') ?></th>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning which Device */ _('Device') ?></th>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning which Relay */ _('Relay') ?></th>
				</tr>
<? foreach( $zf->relay_out as $n=>$or ): ?>
<? if(!$zones->outputIsset($zr,$n)): ?>
<? continue ?>
<? endif ?>
				<tr>
					<td><?= $zones->outputNodeAddress($zr,$n) ?></td>
					<td><?= $zones->outputDeviceTypeString($zr,$n) ?></td>
					<td><?= $zones->outputRelayNumber($zr,$n) ?></td>
				</tr>
<? endforeach; // End Outputs ?>
			</table>
		</td>
	</tr>
	<tr>
		<td class="rowbreak" colspan="3">&nbsp;</td>
	</tr>
<? endif ?>
<? endforeach; // Zone Records ?>
</table>
<? if($_POST['s'] == 3): ?>
<form method="POST" action="/cgi-bin/DeleteZone" target="zone<?= $rand ?>" onSubmit="pleaseWait(); openwin('','zone<?= $rand ?>'); self.close(); ">
	<input type="hidden" name="s" value="0" />
	<input type="hidden" name="zr" value="<?= $_POST['zr'] ?>" />
	<input class="submitbutton" type="submit" name="submit" value="<?=
	/* TRANSLATOR: Button Text */
	_('Confirm Delete') 
	?>" />
</form>
<form method="POST" action="" target="rootDocument" onSubmit="pleaseWait(); self.close(); ">
	<input type="hidden" name="s" value="0" />
	<input class="submitbutton" type="submit" name="submit" value="<?= 
	/* TRANSLATOR: Button Text */
	_('Cancel') 
	?>" />
</form>
<? endif ?>
<? if($_POST['s'] == 4): ?>
<form method="POST" action="/cgi-bin/<?= isset($_POST['Change']) ? 'EditZone' : 'CreateZone' ?>" target="zone<?= $rand ?>" onSubmit="pleaseWait(); openwin('','zone<?= $rand ?>'); self.close(); ">
<? foreach($_POST as $name=>$value): ?>
<? if(strcmp('s',$name) === 0): ?>
<? continue ?>
<? endif ?>
<? $value = strcmp($value,'')===0 ? ' ' : $value; // H4X!! ?>
	<input type="hidden" name="<?= $name ?>" value="<?= $value ?>" />
<? endforeach ?>
<? if( isset($_POST['Change']) ): ?>
	<input type="hidden" name="Change" value="<?= _('Change') ?>" />
<? endif ?>
	<input type="hidden" name="s" value="0" />
	<input class="submitbutton" type="submit" name="submit" value="<?= /* TRANSLATOR: Button Text */ _('Save Zone') ?>" />
</form>
<form method="POST" action="" target="zone<?= $rand ?>" onSubmit="pleaseWait(); openwin('','zone<?= $rand ?>'); self.close(); ">
	<input type="hidden" name="s" value="2" />
	<input type="hidden" name="zr" value="<?= $_POST['zr'] ?>" />
	<input class="submitbutton" type="submit" name="submit" value="<?= /* TRANSLATOR: Button Text */ _('Back') ?>" />
</form>
<form method="POST" action="" target="rootDocument" onSubmit="pleaseWait(); self.close(); ">
	<input type="hidden" name="s" value="0" />
	<input class="submitbutton" type="submit" name="submit" value="<?= _('Cancel') ?>" />
</form>
<? endif ?>
<? break ?>

<? case '1': ?>
 - <?= /* TRANSLATOR: Button Text */ _('Add New Zone Record') ?></h2>
<? case '2': ?>
<? if ($_POST['s'] == 2): ?>
 - <?= /* TRANSLATOR: Button Text */ _('Change Zone Record') ?></h2>
<? endif ?>

<script language="JavaScript" type="text/javascript" >
<!--

var sharedMemoryToInputType = new Array();
<? foreach($ref->sharedMemoryToFtype as $smtype=>$ftype): ?>
sharedMemoryToInputType[<?= $smtype ?>] = new
	Array(
<? foreach($ref->alarmtypesForDeviceBySharedMemory[$smtype] as $k=>$at): ?>
<? end($ref->alarmtypesForDeviceBySharedMemory[$smtype]) ?>
		new Array('<?= 
$ref->inputTypeString[$at] 
					?>',<?= 
$ref->inputTypeToSharedMemory[$at]
					?>)<?= 
key($ref->alarmtypesForDeviceBySharedMemory[$smtype]) === $k ? '' : ',' 
					?>	
<? endforeach; ?>
	);
<? endforeach; ?>

var paramsForInputType = new Array();
<? foreach($ref->paramsForInputType as $it=>$a): ?>
paramsForInputType[<?= $ref->inputTypeToSharedMemory[$it] ?>] = new Array(
<? foreach($a as $k=>$parm): ?>
<? end($a) ?>
<?= $parm ? '1' : '0' ?><?= key($a) === $k ? '' : ',' ?> 
<? endforeach; ?>
);
<? endforeach; ?>

function addOption(it,s,v,sel) {
	var o = document.createElement('option');
	o.text = s;
	o.value = v;
	o.selected = sel;
	try
	{
		it.add(o,null); // standards compliant
	}
	catch(ex)
	{
		it.add(o); // IE only
	}
}

function makeInputTypeMenu(ind,it,sel) {
	var ftype;
	var x;
	ftype = ind.value.replace(/.*\./,"");
	for(x=0; x<sharedMemoryToInputType[ftype].length; x++) {
		addOption(it,sharedMemoryToInputType[ftype][x][0],sharedMemoryToInputType[ftype][x][1],
			(sharedMemoryToInputType[ftype][x][1]==sel ? true : false));
	}
}

function clearInputTypeMenu(it) {
	for(x in it) {
		it.remove(x);
	}
}

function updateForm() {
	var i = 0;
	for(i=1; i<=<?= $zones->maxInputRelay ?>; i++) {
		var ind = document.getElementById('in.' + i + '.nodeAddrDeviceType');
		var it  = document.getElementById('in.' + i + '.inputType');
		if(ind.value != -1) {
			var sel = it.value;
			it.disabled = false;
			it.style.backgroundColor = "#ffffff";
			clearInputTypeMenu(it);
			makeInputTypeMenu(ind,it,sel);
		} else {
			it.disabled = true;
			it.style.backgroundColor = "#aaaaaa";
			clearInputTypeMenu(it);
			addOption(it,'Not Assigned',0);
		}
		var inputtype = document.getElementById('in.' + i + '.inputType').value;
		for(x=0; x<4; x++) {
			var parm = document.getElementById('in.' + i + '.parm' + (x+1));
			if(paramsForInputType[inputtype][x]) {
				parm.disabled = false;
				parm.style.backgroundColor = "#ffffff";
			} else {
				parm.disabled = true;
				parm.value = (x==0 ? -1 : '');
				parm.style.backgroundColor = "#aaaaaa";
			}
		}
	}
	for(i=1; i<=<?= $zones->maxOutputRelay ?>; i++) {
		var ind = document.getElementById('out.' + i + '.nodeAddrDeviceType');
		var it = document.getElementById('out.' + i + '.relayOutputMask');
		if(ind.value != -1) {
			it.disabled = false;
			it.style.backgroundColor = "#ffffff";
		} else {
			it.disabled = true;
			it.value = '';
			it.style.backgroundColor = "#aaaaaa";
		}
	}
}

function startForm() {
	// Could put additional code here if needed
	updateForm();
}

-->
</script>

<? if($zones->haveErrors()): ?>
<? $errormessage = implode("<br>\n",$zones->errors)."\n" ?>
<p>&nbsp;</p>
<div id="errormessage">
<?= $errormessage ?>
</div>
<? endif ?>

<form method="POST" action="/zonecontrol/" name="TheChangeForm" target="zone<?= $rand ?>" onSubmit="pleaseWait(); openwin('','zone<?= $rand ?>'); self.close(); ">
<input type="hidden" name="s" value="4" />
<input type="hidden" name="zr" value="<?= $zr ?>" />
<? if( isset($_POST['Change']) ): ?>
<input type="hidden" name="Change" value="<?= _('Change') ?>" />
<? endif ?>
<input type="hidden" name="zoneId" value="<?= $zones->zoneId($zr) ?>" />
<input type="hidden" name="zoneIsChanging" value="<?= $zoneIsChanging ? 1 : 0 ?>" />
<table class="zone" summary="Current Zone Records">
<? if( $_POST['s'] != 1 ): ?>
<tr><th class="<?= $zones->zoneStateColor($zr) ?>" colspan="8"><?= /* TRANSLATOR: Table Header */ _('Zone Record') ?> <?= $_POST['zr'] ?></th>
<? endif ?>
<tr class="mainheader">
<th colspan="7"><?= /* TRANSLATOR: Field Entry Text.  Status of a zone, which could be Secure, Access, or Unassigned.  */
_('Status') ?></th>
</tr>
<tr>
<td colspan="7">
<select name="state" id="zoneState" onChange="updateForm();">
<? $zs = $zones->zoneStateOrDefault($zr) ?>
<? $zsc = $zones->zoneStateColor($zr) ?>
<? foreach($ref->zoneStatesForUser as $k=>$v): ?>
<option value="<?= $k ?>" 
<?= $zs==$k ? 'selected="selected" ' : '' ?>
class="strong <?= strtolower($v) ?>"><?= _($v) ?></option>
<? endforeach ?>
</select>
</td>
</tr>

<tr class="mainheader">
<th colspan="7"><?= /* TRANSLATOR: Field Entry Text */ _('Name') ?></th>
</tr>
<tr>
<td colspan="7">
<input type="text" name="zoneName" size="67" maxlength="67" value="<?= $zones->zoneName($zr) ?>" />
</td>
</tr>
<tr class="mainheader">
<th colspan="7"><?= /* TRANSLATOR: Field Entry Text */ _('Comment') ?></th>
</tr>

<tr>
<td colspan="7">
<input type="text" name="zoneComment" size="67" maxlength="67" value="<?= $zones->zoneComment($zr) ?>" />
</td>
</tr>
<tr class="mainheader">
<th colspan="7"><?= /* TRANSLATOR: Field Entry Text */ _('Assigned Inputs') ?></th>
</tr>
<tr>
	<th>&nbsp;</th>
	<th><?= /* TRANSLATOR: Table Header */ _('Device') ?></th>
	<th><?= /* TRANSLATOR: Table Header */ _('Input') ?></th>
	<th><?= /* TRANSLATOR: Table Header */ _('Cable Id') ?></th>
	<th><?= /* TRANSLATOR: Table Header */ str_replace(' ','<br>',_('Start Subcell Number')) ?></th>
	<th><?= /* TRANSLATOR: Table Header */ str_replace(' ','<br>',_('End Subcell Number')) ?></th>
	<th><?= /* TRANSLATOR: Table Header.  Meaning which Input Relay. */ str_replace(' ','<br>',_('Input Relay Number')) ?></th>
</tr>

<? for($i=1; $i<=$zones->maxInputRelay; $i++): ?>

<tr>
<td><?= $i ?></td>
<td>

<select name="in.<?= $i ?>.nodeAddrDeviceType" id="in.<?= $i ?>.nodeAddrDeviceType" onChange="updateForm();">
<option label="Not Assigned" value="-1"><?= /* TRANSLATOR: Option list entry */ _('Not Assigned') ?></option>
<? $t = $zones->inputNodeAddr($zr,$i) ?>
<? foreach ($devices->device as $key => $device): ?>
<? if ($ref->isInput($device->ftype)): ?>
<? $label = $device->nAddr .' : '. $ref->deviceString[$device->ftype] .' - '. $device->tagName ?> 
<option label="<?= $label ?>" 
value="<?= $device->nAddr ?>.<?= $ref->ftypeToSharedMemory[$device->ftype] ?>"
<?= $t == $device->nAddr ? ' selected="selected" ' : '' ?>
>
<?= $label ?> 
</option>
<? endif ?>
<? endforeach ?>
</select>
</td>

<td>
<select name="in.<?= $i ?>.inputType" id="in.<?= $i ?>.inputType" onChange="updateForm();">
<? $t = $zones->inputType($zr,$i) ?>
<? foreach ($ref->inputTypeString as $id => $alarm): ?>
<? $label = "$id : $alarm" ?>
<option label="<?= $label ?>" 
value="<?= $ref->inputTypeToSharedMemory[$id] ?>"
<?= $t == $id ? ' selected="selected" ' : '' ?>
>
<?= $label ?>
</option>
<? endforeach ?>
</select>
</td>

<td>
<select name="in.<?= $i ?>.parm1" id="in.<?= $i ?>.parm1" onChange="updateForm();">
<? $t = $zones->inputCableId($zr,$i) ?>
<option label="Not Assigned" value="-1"><?= _('Not Assigned') ?></option>
<? foreach ($ref->cableIdString as $id => $s): ?>
<option label="<?= $s ?>" 
value="<?= $id ?>"
<?= $t == $id ? ' selected="selected" ' : '' ?>
>
<?= $s ?>
</option>
<? endforeach ?>
</select>
</td>

<td>
<input name="in.<?= $i ?>.parm2" id="in.<?= $i ?>.parm2" onChange="updateForm();" type="text" size="3" maxlength="3" 
value="<?= $zones->inputStartSubcellDisplay($zr,$i) ?>" />
</td>

<td>
<input name="in.<?= $i ?>.parm3" id="in.<?= $i ?>.parm3" onChange="updateForm();" type="text" size="3" maxlength="3" 
value="<?= $zones->inputEndSubcellDisplay($zr,$i) ?>" />
</td>

<td>
<input name="in.<?= $i ?>.parm4" id="in.<?= $i ?>.parm4" onChange="updateForm();" type="text" size="3" maxlength="3" 
value="<?= $zones->inputRelayNumberDisplay($zr,$i) ?>" />
</td>
</tr>

<? endfor ?>

<tr class="mainheader">
<th colspan="7"><?= /* TRANSLATOR: Table Header */ _('Assigned Outputs') ?></th>
</th>
</tr>
<tr>
	<th>&nbsp;</th>
	<th><?= _('Device') ?></th>
	<th><?= _('Relay') ?></th>
</tr>

<? for($i=1; $i<=$zones->maxOutputRelay; $i++): ?>

<tr>
<td><?= $i ?></td>
<td>
<select name="out.<?= $i ?>.nodeAddrDeviceType" id="out.<?= $i ?>.nodeAddrDeviceType" onChange="updateForm();">
<? $t = $zones->outputNodeAddress($zr,$i) ?>
<option label="Not Assigned" value="-1"><?= _('Not Assigned') ?></option>
<? foreach ($devices->device as $key => $device): ?>
<? if ($ref->isOutput($device->ftype)): ?>
<? $label = $device->nAddr .' '. $ref->deviceString[$device->ftype] .' : '. $device->tagName ?> 
<option label="<?= $label ?>"
value="<?= $device->nAddr ?>.<?= $ref->ftypeToSharedMemory[$device->ftype] ?>"
<?= $t == $device->nAddr ? ' selected="selected" ' : '' ?>
>
<?= $label ?>
</option> 
<? endif ?>
<? endforeach ?>
</select>
</td>

<td>
<input name="out.<?= $i ?>.relayOutputMask" id="out.<?= $i ?>.relayOutputMask" onChange="updateForm();" type="text" size="3" maxlength="3" 
value="<?= $zones->outputRelayNumberDisplay($zr,$i) ?>" >
</td>
</tr>

<? endfor ?>
</tr>
</table>

<input class="submitbutton" type="reset" name="reset" value="<?= _('Reset') ?>" />
<input class="submitbutton" type="submit" name="submit" value="<?= _('Submit') ?>" />
</form>

<form method="POST" action="" target="rootDocument" onSubmit="pleaseWait(); self.close(); ">
<input type="hidden" name="s" value="0" />
<input class="submitbutton" type="submit" name="submit" value="<?= _('Cancel') ?>" />
</form>

<? break ?>

<? endswitch ?>

<p>&nbsp;</p>

<pre>
<? print_r($_POST) ?>
<? print_r($zones) ?>
</pre>
